_ruff() {
    local i cur prev opts cmd
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"
    cmd=""
    opts=""

    for i in ${COMP_WORDS[@]}
    do
        case "${cmd},${i}" in
            ",$1")
                cmd="ruff"
                ;;
            ruff,check)
                cmd="ruff__check"
                ;;
            ruff,clean)
                cmd="ruff__clean"
                ;;
            ruff,config)
                cmd="ruff__config"
                ;;
            ruff,generate-shell-completion)
                cmd="ruff__generate__shell__completion"
                ;;
            ruff,help)
                cmd="ruff__help"
                ;;
            ruff,linter)
                cmd="ruff__linter"
                ;;
            ruff,rule)
                cmd="ruff__rule"
                ;;
            ruff__help,check)
                cmd="ruff__help__check"
                ;;
            ruff__help,clean)
                cmd="ruff__help__clean"
                ;;
            ruff__help,config)
                cmd="ruff__help__config"
                ;;
            ruff__help,generate-shell-completion)
                cmd="ruff__help__generate__shell__completion"
                ;;
            ruff__help,help)
                cmd="ruff__help__help"
                ;;
            ruff__help,linter)
                cmd="ruff__help__linter"
                ;;
            ruff__help,rule)
                cmd="ruff__help__rule"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        ruff)
            opts="-v -q -s -h -V --verbose --quiet --silent --help --version check rule config linter clean generate-shell-completion help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__check)
            opts="-w -n -e -v -q -s -h --fix --no-fix --show-source --no-show-source --show-fixes --no-show-fixes --diff --watch --fix-only --no-fix-only --ignore-noqa --format --target-version --config --select --ignore --extend-select --extend-ignore --per-file-ignores --exclude --extend-exclude --fixable --unfixable --respect-gitignore --no-respect-gitignore --force-exclude --no-force-exclude --line-length --dummy-variable-rgx --no-cache --isolated --cache-dir --stdin-filename --exit-zero --exit-non-zero-on-fix --update-check --no-update-check --statistics --add-noqa --show-files --show-settings --verbose --quiet --silent --help [FILES]..."
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --format)
                    COMPREPLY=($(compgen -W "text json junit grouped github gitlab pylint" -- "${cur}"))
                    return 0
                    ;;
                --target-version)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --config)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --select)
                    COMPREPLY=($(compgen -W "ALL F C90 I N D UP YTT ANN S BLE FBT B A COM C4 DTZ T10 DJ EM EXE ISC ICN G INP PIE T20 PYI PT Q RSE RET SLF SIM TID TCH ARG PTH ERA PD PGH PL TRY NPY RUF ERA0 ERA00 ERA001 YTT10 YTT3 YTT103 YTT203 YTT301 YTT2 YTT20 YTT201 YTT204 YTT303 YTT30 YTT202 YTT102 YTT101 YTT302 YTT1 ANN4 ANN101 ANN00 ANN1 ANN002 ANN201 ANN205 ANN401 ANN206 ANN40 ANN10 ANN001 ANN20 ANN003 ANN0 ANN202 ANN204 ANN2 ANN102 S102 S103 S50 S3 S501 S1 S60 S105 S506 S324 S5 S104 S106 S112 S101 S509 S11 S32 S61 S107 S7 S113 S612 S110 S608 S70 S701 S508 S10 S108 S6 BLE001 BLE0 BLE00 FBT0 FBT001 FBT00 FBT003 FBT002 B023 B014 B025 B01 B020 B007 B027 B904 B013 B018 B905 B9 B0 B032 B02 B008 B009 B024 B03 B026 B022 B019 B005 B00 B003 B011 B021 B90 B010 B004 B017 B012 B016 B002 B006 B015 B029 A00 A0 A001 A003 A002 COM818 COM8 COM819 COM81 COM812 C410 C400 C414 C402 C404 C415 C417 C41 C416 C409 C401 C413 C40 C403 C405 C408 C411 C406 DTZ01 DTZ002 DTZ007 DTZ001 DTZ004 DTZ003 DTZ0 DTZ00 DTZ006 DTZ005 DTZ011 DTZ012 T100 DJ008 DJ001 DJ0 DJ003 DJ007 DJ006 DJ013 DJ00 DJ01 EM102 EM101 EM1 EM103 EM10 EXE003 EXE0 EXE00 EXE002 EXE005 EXE001 EXE004 ISC00 ISC002 ISC001 ISC003 ISC0 ICN00 ICN001 ICN0 G010 G101 G2 G01 G1 G004 G003 G10 G002 G0 G00 G201 G202 G001 G20 INP001 INP0 INP00 PIE807 PIE802 PIE80 PIE796 PIE810 PIE79 PIE7 PIE800 PIE790 PIE794 PIE8 PIE81 PIE804 T203 T201 PYI03 PYI007 PYI021 PYI02 PYI001 PYI006 PYI010 PYI014 PYI0 PYI009 PYI008 PYI033 PYI00 PYI011 PYI01 PT007 PT017 PT023 PT02 PT005 PT010 PT020 PT021 PT024 PT00 PT012 PT003 PT01 PT026 PT008 PT001 PT018 PT006 PT015 PT022 PT002 PT004 PT009 PT013 PT016 PT019 PT025 PT0 PT011 Q003 Q000 Q002 Q0 Q00 Q001 RSE102 RSE1 RSE10 RET50 RET504 RET508 RET501 RET502 RET503 RET505 RET507 RET5 RET506 SLF00 SLF0 SLF001 SIM2 SIM112 SIM201 SIM103 SIM110 SIM115 SIM223 SIM222 SIM109 SIM3 SIM401 SIM102 SIM1 SIM108 SIM210 SIM20 SIM105 SIM107 SIM4 SIM118 SIM116 SIM211 SIM10 SIM40 SIM221 SIM30 SIM114 SIM22 SIM117 SIM208 SIM300 SIM202 SIM21 SIM101 SIM220 SIM212 SIM11 TID251 TID252 TID2 TID25 TCH003 TCH004 TCH002 TCH001 TCH005 TCH0 TCH00 ARG003 ARG0 ARG00 ARG002 ARG005 ARG004 ARG001 PTH116 PTH122 PTH104 PTH110 PTH121 PTH108 PTH123 PTH107 PTH119 PTH10 PTH118 PTH101 PTH114 PTH100 PTH11 PTH102 PTH120 PTH124 PTH1 PTH111 PTH105 PTH113 PTH117 PTH115 PTH103 PTH109 PTH106 PTH12 PTH112 I00 I0 I002 I001 C901 NPY0 NPY00 NPY001 NPY002 N805 N81 N804 N999 N802 N807 N815 N818 N80 N816 N806 N811 N813 N803 N8 N99 N812 N9 N801 N817 N814 PD9 PD015 PD002 PD013 PD01 PD0 PD00 PD901 PD003 PD012 PD008 PD009 PD010 PD007 PD004 PD011 PD90 W292 E7 E73 W5 W6 W60 E40 E402 E71 W29 E702 E501 E99 E713 E10 E50 E70 E72 W293 E742 W291 E9 W19 E711 W2 E731 E401 E721 E74 W1 E1 W605 E703 E714 E902 W505 E4 E90 E E712 W191 E701 E5 E743 W W50 E722 E999 E741 E101 D300 D103 D405 D4 D40 D205 D213 D409 D417 D200 D401 D402 D410 D105 D202 D209 D107 D214 D407 D414 D416 D418 D10 D211 D400 D408 D20 D104 D301 D203 D208 D419 D207 D100 D21 D101 D212 D210 D204 D3 D30 D102 D106 D41 D403 D406 D415 D413 D404 D412 D411 D1 D2 D201 D206 D215 F622 F602 F84 F404 F503 F60 F81 F407 F842 F40 F508 F901 F54 F525 F707 F521 F6 F50 F70 F9 F841 F632 F401 F403 F811 F541 F702 F505 F72 F504 F4 F523 F621 F52 F701 F631 F821 F8 F509 F405 F507 F506 F722 F62 F82 F634 F7 F706 F502 F601 F63 F406 F402 F501 F524 F90 F522 F823 F633 F822 F704 F5 PGH003 PGH002 PGH004 PGH001 PGH0 PGH00 PLR02 PLR2 PLW012 PLR PLR091 PLW0120 PLW0603 PLE1142 PLR0206 PLE PLE1307 PLR1722 PLR5501 PLR04 PLC30 PLE130 PLR5 PLW29 PLE1205 PLR20 PLC300 PLE11 PLW01 PLE0100 PLC3 PLW290 PLC0 PLE0117 PLC0414 PLR0912 PLR1701 PLE25 PLR09 PLR0402 PLC041 PLE250 PLE0101 PLE1310 PLR0911 PLR0915 PLR17 PLE011 PLE13 PLE1206 PLE0604 PLE01 PLE131 PLE010 PLR2004 PLR170 PLR172 PLW PLW060 PLE120 PLE0 PLC04 PLE2502 PLR0913 PLR020 PLE2 PLR0133 PLR040 PLR55 PLE1 PLR550 PLW2 PLR200 PLE12 PLW06 PLE060 PLC3002 PLW2901 PLR0 PLE0605 PLE114 PLC PLW0 PLW0602 PLE0118 PLE06 PLR1 PLR01 PLR013 UP021 UP010 UP011 UP01 UP03 UP025 UP035 UP026 UP030 UP001 UP0 UP007 UP003 UP017 UP022 UP037 UP009 UP038 UP006 UP008 UP023 UP013 UP032 UP004 UP018 UP031 UP00 UP005 UP020 UP029 UP02 UP014 UP012 UP015 UP019 UP024 UP028 UP033 UP034 UP036 UP027 RUF006 RUF00 RUF1 RUF001 RUF100 RUF005 RUF002 RUF10 RUF0 RUF003 TRY20 TRY200 TRY300 TRY201 TRY401 TRY40 TRY004 TRY002 TRY30 TRY00 TRY0 TRY4 TRY2 TRY301 TRY003 TRY400 TRY3" -- "${cur}"))
                    return 0
                    ;;
                --ignore)
                    COMPREPLY=($(compgen -W "ALL F C90 I N D UP YTT ANN S BLE FBT B A COM C4 DTZ T10 DJ EM EXE ISC ICN G INP PIE T20 PYI PT Q RSE RET SLF SIM TID TCH ARG PTH ERA PD PGH PL TRY NPY RUF ERA0 ERA00 ERA001 YTT10 YTT3 YTT103 YTT203 YTT301 YTT2 YTT20 YTT201 YTT204 YTT303 YTT30 YTT202 YTT102 YTT101 YTT302 YTT1 ANN4 ANN101 ANN00 ANN1 ANN002 ANN201 ANN205 ANN401 ANN206 ANN40 ANN10 ANN001 ANN20 ANN003 ANN0 ANN202 ANN204 ANN2 ANN102 S102 S103 S50 S3 S501 S1 S60 S105 S506 S324 S5 S104 S106 S112 S101 S509 S11 S32 S61 S107 S7 S113 S612 S110 S608 S70 S701 S508 S10 S108 S6 BLE001 BLE0 BLE00 FBT0 FBT001 FBT00 FBT003 FBT002 B023 B014 B025 B01 B020 B007 B027 B904 B013 B018 B905 B9 B0 B032 B02 B008 B009 B024 B03 B026 B022 B019 B005 B00 B003 B011 B021 B90 B010 B004 B017 B012 B016 B002 B006 B015 B029 A00 A0 A001 A003 A002 COM818 COM8 COM819 COM81 COM812 C410 C400 C414 C402 C404 C415 C417 C41 C416 C409 C401 C413 C40 C403 C405 C408 C411 C406 DTZ01 DTZ002 DTZ007 DTZ001 DTZ004 DTZ003 DTZ0 DTZ00 DTZ006 DTZ005 DTZ011 DTZ012 T100 DJ008 DJ001 DJ0 DJ003 DJ007 DJ006 DJ013 DJ00 DJ01 EM102 EM101 EM1 EM103 EM10 EXE003 EXE0 EXE00 EXE002 EXE005 EXE001 EXE004 ISC00 ISC002 ISC001 ISC003 ISC0 ICN00 ICN001 ICN0 G010 G101 G2 G01 G1 G004 G003 G10 G002 G0 G00 G201 G202 G001 G20 INP001 INP0 INP00 PIE807 PIE802 PIE80 PIE796 PIE810 PIE79 PIE7 PIE800 PIE790 PIE794 PIE8 PIE81 PIE804 T203 T201 PYI03 PYI007 PYI021 PYI02 PYI001 PYI006 PYI010 PYI014 PYI0 PYI009 PYI008 PYI033 PYI00 PYI011 PYI01 PT007 PT017 PT023 PT02 PT005 PT010 PT020 PT021 PT024 PT00 PT012 PT003 PT01 PT026 PT008 PT001 PT018 PT006 PT015 PT022 PT002 PT004 PT009 PT013 PT016 PT019 PT025 PT0 PT011 Q003 Q000 Q002 Q0 Q00 Q001 RSE102 RSE1 RSE10 RET50 RET504 RET508 RET501 RET502 RET503 RET505 RET507 RET5 RET506 SLF00 SLF0 SLF001 SIM2 SIM112 SIM201 SIM103 SIM110 SIM115 SIM223 SIM222 SIM109 SIM3 SIM401 SIM102 SIM1 SIM108 SIM210 SIM20 SIM105 SIM107 SIM4 SIM118 SIM116 SIM211 SIM10 SIM40 SIM221 SIM30 SIM114 SIM22 SIM117 SIM208 SIM300 SIM202 SIM21 SIM101 SIM220 SIM212 SIM11 TID251 TID252 TID2 TID25 TCH003 TCH004 TCH002 TCH001 TCH005 TCH0 TCH00 ARG003 ARG0 ARG00 ARG002 ARG005 ARG004 ARG001 PTH116 PTH122 PTH104 PTH110 PTH121 PTH108 PTH123 PTH107 PTH119 PTH10 PTH118 PTH101 PTH114 PTH100 PTH11 PTH102 PTH120 PTH124 PTH1 PTH111 PTH105 PTH113 PTH117 PTH115 PTH103 PTH109 PTH106 PTH12 PTH112 I00 I0 I002 I001 C901 NPY0 NPY00 NPY001 NPY002 N805 N81 N804 N999 N802 N807 N815 N818 N80 N816 N806 N811 N813 N803 N8 N99 N812 N9 N801 N817 N814 PD9 PD015 PD002 PD013 PD01 PD0 PD00 PD901 PD003 PD012 PD008 PD009 PD010 PD007 PD004 PD011 PD90 W292 E7 E73 W5 W6 W60 E40 E402 E71 W29 E702 E501 E99 E713 E10 E50 E70 E72 W293 E742 W291 E9 W19 E711 W2 E731 E401 E721 E74 W1 E1 W605 E703 E714 E902 W505 E4 E90 E E712 W191 E701 E5 E743 W W50 E722 E999 E741 E101 D300 D103 D405 D4 D40 D205 D213 D409 D417 D200 D401 D402 D410 D105 D202 D209 D107 D214 D407 D414 D416 D418 D10 D211 D400 D408 D20 D104 D301 D203 D208 D419 D207 D100 D21 D101 D212 D210 D204 D3 D30 D102 D106 D41 D403 D406 D415 D413 D404 D412 D411 D1 D2 D201 D206 D215 F622 F602 F84 F404 F503 F60 F81 F407 F842 F40 F508 F901 F54 F525 F707 F521 F6 F50 F70 F9 F841 F632 F401 F403 F811 F541 F702 F505 F72 F504 F4 F523 F621 F52 F701 F631 F821 F8 F509 F405 F507 F506 F722 F62 F82 F634 F7 F706 F502 F601 F63 F406 F402 F501 F524 F90 F522 F823 F633 F822 F704 F5 PGH003 PGH002 PGH004 PGH001 PGH0 PGH00 PLR02 PLR2 PLW012 PLR PLR091 PLW0120 PLW0603 PLE1142 PLR0206 PLE PLE1307 PLR1722 PLR5501 PLR04 PLC30 PLE130 PLR5 PLW29 PLE1205 PLR20 PLC300 PLE11 PLW01 PLE0100 PLC3 PLW290 PLC0 PLE0117 PLC0414 PLR0912 PLR1701 PLE25 PLR09 PLR0402 PLC041 PLE250 PLE0101 PLE1310 PLR0911 PLR0915 PLR17 PLE011 PLE13 PLE1206 PLE0604 PLE01 PLE131 PLE010 PLR2004 PLR170 PLR172 PLW PLW060 PLE120 PLE0 PLC04 PLE2502 PLR0913 PLR020 PLE2 PLR0133 PLR040 PLR55 PLE1 PLR550 PLW2 PLR200 PLE12 PLW06 PLE060 PLC3002 PLW2901 PLR0 PLE0605 PLE114 PLC PLW0 PLW0602 PLE0118 PLE06 PLR1 PLR01 PLR013 UP021 UP010 UP011 UP01 UP03 UP025 UP035 UP026 UP030 UP001 UP0 UP007 UP003 UP017 UP022 UP037 UP009 UP038 UP006 UP008 UP023 UP013 UP032 UP004 UP018 UP031 UP00 UP005 UP020 UP029 UP02 UP014 UP012 UP015 UP019 UP024 UP028 UP033 UP034 UP036 UP027 RUF006 RUF00 RUF1 RUF001 RUF100 RUF005 RUF002 RUF10 RUF0 RUF003 TRY20 TRY200 TRY300 TRY201 TRY401 TRY40 TRY004 TRY002 TRY30 TRY00 TRY0 TRY4 TRY2 TRY301 TRY003 TRY400 TRY3" -- "${cur}"))
                    return 0
                    ;;
                --extend-select)
                    COMPREPLY=($(compgen -W "ALL F C90 I N D UP YTT ANN S BLE FBT B A COM C4 DTZ T10 DJ EM EXE ISC ICN G INP PIE T20 PYI PT Q RSE RET SLF SIM TID TCH ARG PTH ERA PD PGH PL TRY NPY RUF ERA0 ERA00 ERA001 YTT10 YTT3 YTT103 YTT203 YTT301 YTT2 YTT20 YTT201 YTT204 YTT303 YTT30 YTT202 YTT102 YTT101 YTT302 YTT1 ANN4 ANN101 ANN00 ANN1 ANN002 ANN201 ANN205 ANN401 ANN206 ANN40 ANN10 ANN001 ANN20 ANN003 ANN0 ANN202 ANN204 ANN2 ANN102 S102 S103 S50 S3 S501 S1 S60 S105 S506 S324 S5 S104 S106 S112 S101 S509 S11 S32 S61 S107 S7 S113 S612 S110 S608 S70 S701 S508 S10 S108 S6 BLE001 BLE0 BLE00 FBT0 FBT001 FBT00 FBT003 FBT002 B023 B014 B025 B01 B020 B007 B027 B904 B013 B018 B905 B9 B0 B032 B02 B008 B009 B024 B03 B026 B022 B019 B005 B00 B003 B011 B021 B90 B010 B004 B017 B012 B016 B002 B006 B015 B029 A00 A0 A001 A003 A002 COM818 COM8 COM819 COM81 COM812 C410 C400 C414 C402 C404 C415 C417 C41 C416 C409 C401 C413 C40 C403 C405 C408 C411 C406 DTZ01 DTZ002 DTZ007 DTZ001 DTZ004 DTZ003 DTZ0 DTZ00 DTZ006 DTZ005 DTZ011 DTZ012 T100 DJ008 DJ001 DJ0 DJ003 DJ007 DJ006 DJ013 DJ00 DJ01 EM102 EM101 EM1 EM103 EM10 EXE003 EXE0 EXE00 EXE002 EXE005 EXE001 EXE004 ISC00 ISC002 ISC001 ISC003 ISC0 ICN00 ICN001 ICN0 G010 G101 G2 G01 G1 G004 G003 G10 G002 G0 G00 G201 G202 G001 G20 INP001 INP0 INP00 PIE807 PIE802 PIE80 PIE796 PIE810 PIE79 PIE7 PIE800 PIE790 PIE794 PIE8 PIE81 PIE804 T203 T201 PYI03 PYI007 PYI021 PYI02 PYI001 PYI006 PYI010 PYI014 PYI0 PYI009 PYI008 PYI033 PYI00 PYI011 PYI01 PT007 PT017 PT023 PT02 PT005 PT010 PT020 PT021 PT024 PT00 PT012 PT003 PT01 PT026 PT008 PT001 PT018 PT006 PT015 PT022 PT002 PT004 PT009 PT013 PT016 PT019 PT025 PT0 PT011 Q003 Q000 Q002 Q0 Q00 Q001 RSE102 RSE1 RSE10 RET50 RET504 RET508 RET501 RET502 RET503 RET505 RET507 RET5 RET506 SLF00 SLF0 SLF001 SIM2 SIM112 SIM201 SIM103 SIM110 SIM115 SIM223 SIM222 SIM109 SIM3 SIM401 SIM102 SIM1 SIM108 SIM210 SIM20 SIM105 SIM107 SIM4 SIM118 SIM116 SIM211 SIM10 SIM40 SIM221 SIM30 SIM114 SIM22 SIM117 SIM208 SIM300 SIM202 SIM21 SIM101 SIM220 SIM212 SIM11 TID251 TID252 TID2 TID25 TCH003 TCH004 TCH002 TCH001 TCH005 TCH0 TCH00 ARG003 ARG0 ARG00 ARG002 ARG005 ARG004 ARG001 PTH116 PTH122 PTH104 PTH110 PTH121 PTH108 PTH123 PTH107 PTH119 PTH10 PTH118 PTH101 PTH114 PTH100 PTH11 PTH102 PTH120 PTH124 PTH1 PTH111 PTH105 PTH113 PTH117 PTH115 PTH103 PTH109 PTH106 PTH12 PTH112 I00 I0 I002 I001 C901 NPY0 NPY00 NPY001 NPY002 N805 N81 N804 N999 N802 N807 N815 N818 N80 N816 N806 N811 N813 N803 N8 N99 N812 N9 N801 N817 N814 PD9 PD015 PD002 PD013 PD01 PD0 PD00 PD901 PD003 PD012 PD008 PD009 PD010 PD007 PD004 PD011 PD90 W292 E7 E73 W5 W6 W60 E40 E402 E71 W29 E702 E501 E99 E713 E10 E50 E70 E72 W293 E742 W291 E9 W19 E711 W2 E731 E401 E721 E74 W1 E1 W605 E703 E714 E902 W505 E4 E90 E E712 W191 E701 E5 E743 W W50 E722 E999 E741 E101 D300 D103 D405 D4 D40 D205 D213 D409 D417 D200 D401 D402 D410 D105 D202 D209 D107 D214 D407 D414 D416 D418 D10 D211 D400 D408 D20 D104 D301 D203 D208 D419 D207 D100 D21 D101 D212 D210 D204 D3 D30 D102 D106 D41 D403 D406 D415 D413 D404 D412 D411 D1 D2 D201 D206 D215 F622 F602 F84 F404 F503 F60 F81 F407 F842 F40 F508 F901 F54 F525 F707 F521 F6 F50 F70 F9 F841 F632 F401 F403 F811 F541 F702 F505 F72 F504 F4 F523 F621 F52 F701 F631 F821 F8 F509 F405 F507 F506 F722 F62 F82 F634 F7 F706 F502 F601 F63 F406 F402 F501 F524 F90 F522 F823 F633 F822 F704 F5 PGH003 PGH002 PGH004 PGH001 PGH0 PGH00 PLR02 PLR2 PLW012 PLR PLR091 PLW0120 PLW0603 PLE1142 PLR0206 PLE PLE1307 PLR1722 PLR5501 PLR04 PLC30 PLE130 PLR5 PLW29 PLE1205 PLR20 PLC300 PLE11 PLW01 PLE0100 PLC3 PLW290 PLC0 PLE0117 PLC0414 PLR0912 PLR1701 PLE25 PLR09 PLR0402 PLC041 PLE250 PLE0101 PLE1310 PLR0911 PLR0915 PLR17 PLE011 PLE13 PLE1206 PLE0604 PLE01 PLE131 PLE010 PLR2004 PLR170 PLR172 PLW PLW060 PLE120 PLE0 PLC04 PLE2502 PLR0913 PLR020 PLE2 PLR0133 PLR040 PLR55 PLE1 PLR550 PLW2 PLR200 PLE12 PLW06 PLE060 PLC3002 PLW2901 PLR0 PLE0605 PLE114 PLC PLW0 PLW0602 PLE0118 PLE06 PLR1 PLR01 PLR013 UP021 UP010 UP011 UP01 UP03 UP025 UP035 UP026 UP030 UP001 UP0 UP007 UP003 UP017 UP022 UP037 UP009 UP038 UP006 UP008 UP023 UP013 UP032 UP004 UP018 UP031 UP00 UP005 UP020 UP029 UP02 UP014 UP012 UP015 UP019 UP024 UP028 UP033 UP034 UP036 UP027 RUF006 RUF00 RUF1 RUF001 RUF100 RUF005 RUF002 RUF10 RUF0 RUF003 TRY20 TRY200 TRY300 TRY201 TRY401 TRY40 TRY004 TRY002 TRY30 TRY00 TRY0 TRY4 TRY2 TRY301 TRY003 TRY400 TRY3" -- "${cur}"))
                    return 0
                    ;;
                --extend-ignore)
                    COMPREPLY=($(compgen -W "ALL F C90 I N D UP YTT ANN S BLE FBT B A COM C4 DTZ T10 DJ EM EXE ISC ICN G INP PIE T20 PYI PT Q RSE RET SLF SIM TID TCH ARG PTH ERA PD PGH PL TRY NPY RUF ERA0 ERA00 ERA001 YTT10 YTT3 YTT103 YTT203 YTT301 YTT2 YTT20 YTT201 YTT204 YTT303 YTT30 YTT202 YTT102 YTT101 YTT302 YTT1 ANN4 ANN101 ANN00 ANN1 ANN002 ANN201 ANN205 ANN401 ANN206 ANN40 ANN10 ANN001 ANN20 ANN003 ANN0 ANN202 ANN204 ANN2 ANN102 S102 S103 S50 S3 S501 S1 S60 S105 S506 S324 S5 S104 S106 S112 S101 S509 S11 S32 S61 S107 S7 S113 S612 S110 S608 S70 S701 S508 S10 S108 S6 BLE001 BLE0 BLE00 FBT0 FBT001 FBT00 FBT003 FBT002 B023 B014 B025 B01 B020 B007 B027 B904 B013 B018 B905 B9 B0 B032 B02 B008 B009 B024 B03 B026 B022 B019 B005 B00 B003 B011 B021 B90 B010 B004 B017 B012 B016 B002 B006 B015 B029 A00 A0 A001 A003 A002 COM818 COM8 COM819 COM81 COM812 C410 C400 C414 C402 C404 C415 C417 C41 C416 C409 C401 C413 C40 C403 C405 C408 C411 C406 DTZ01 DTZ002 DTZ007 DTZ001 DTZ004 DTZ003 DTZ0 DTZ00 DTZ006 DTZ005 DTZ011 DTZ012 T100 DJ008 DJ001 DJ0 DJ003 DJ007 DJ006 DJ013 DJ00 DJ01 EM102 EM101 EM1 EM103 EM10 EXE003 EXE0 EXE00 EXE002 EXE005 EXE001 EXE004 ISC00 ISC002 ISC001 ISC003 ISC0 ICN00 ICN001 ICN0 G010 G101 G2 G01 G1 G004 G003 G10 G002 G0 G00 G201 G202 G001 G20 INP001 INP0 INP00 PIE807 PIE802 PIE80 PIE796 PIE810 PIE79 PIE7 PIE800 PIE790 PIE794 PIE8 PIE81 PIE804 T203 T201 PYI03 PYI007 PYI021 PYI02 PYI001 PYI006 PYI010 PYI014 PYI0 PYI009 PYI008 PYI033 PYI00 PYI011 PYI01 PT007 PT017 PT023 PT02 PT005 PT010 PT020 PT021 PT024 PT00 PT012 PT003 PT01 PT026 PT008 PT001 PT018 PT006 PT015 PT022 PT002 PT004 PT009 PT013 PT016 PT019 PT025 PT0 PT011 Q003 Q000 Q002 Q0 Q00 Q001 RSE102 RSE1 RSE10 RET50 RET504 RET508 RET501 RET502 RET503 RET505 RET507 RET5 RET506 SLF00 SLF0 SLF001 SIM2 SIM112 SIM201 SIM103 SIM110 SIM115 SIM223 SIM222 SIM109 SIM3 SIM401 SIM102 SIM1 SIM108 SIM210 SIM20 SIM105 SIM107 SIM4 SIM118 SIM116 SIM211 SIM10 SIM40 SIM221 SIM30 SIM114 SIM22 SIM117 SIM208 SIM300 SIM202 SIM21 SIM101 SIM220 SIM212 SIM11 TID251 TID252 TID2 TID25 TCH003 TCH004 TCH002 TCH001 TCH005 TCH0 TCH00 ARG003 ARG0 ARG00 ARG002 ARG005 ARG004 ARG001 PTH116 PTH122 PTH104 PTH110 PTH121 PTH108 PTH123 PTH107 PTH119 PTH10 PTH118 PTH101 PTH114 PTH100 PTH11 PTH102 PTH120 PTH124 PTH1 PTH111 PTH105 PTH113 PTH117 PTH115 PTH103 PTH109 PTH106 PTH12 PTH112 I00 I0 I002 I001 C901 NPY0 NPY00 NPY001 NPY002 N805 N81 N804 N999 N802 N807 N815 N818 N80 N816 N806 N811 N813 N803 N8 N99 N812 N9 N801 N817 N814 PD9 PD015 PD002 PD013 PD01 PD0 PD00 PD901 PD003 PD012 PD008 PD009 PD010 PD007 PD004 PD011 PD90 W292 E7 E73 W5 W6 W60 E40 E402 E71 W29 E702 E501 E99 E713 E10 E50 E70 E72 W293 E742 W291 E9 W19 E711 W2 E731 E401 E721 E74 W1 E1 W605 E703 E714 E902 W505 E4 E90 E E712 W191 E701 E5 E743 W W50 E722 E999 E741 E101 D300 D103 D405 D4 D40 D205 D213 D409 D417 D200 D401 D402 D410 D105 D202 D209 D107 D214 D407 D414 D416 D418 D10 D211 D400 D408 D20 D104 D301 D203 D208 D419 D207 D100 D21 D101 D212 D210 D204 D3 D30 D102 D106 D41 D403 D406 D415 D413 D404 D412 D411 D1 D2 D201 D206 D215 F622 F602 F84 F404 F503 F60 F81 F407 F842 F40 F508 F901 F54 F525 F707 F521 F6 F50 F70 F9 F841 F632 F401 F403 F811 F541 F702 F505 F72 F504 F4 F523 F621 F52 F701 F631 F821 F8 F509 F405 F507 F506 F722 F62 F82 F634 F7 F706 F502 F601 F63 F406 F402 F501 F524 F90 F522 F823 F633 F822 F704 F5 PGH003 PGH002 PGH004 PGH001 PGH0 PGH00 PLR02 PLR2 PLW012 PLR PLR091 PLW0120 PLW0603 PLE1142 PLR0206 PLE PLE1307 PLR1722 PLR5501 PLR04 PLC30 PLE130 PLR5 PLW29 PLE1205 PLR20 PLC300 PLE11 PLW01 PLE0100 PLC3 PLW290 PLC0 PLE0117 PLC0414 PLR0912 PLR1701 PLE25 PLR09 PLR0402 PLC041 PLE250 PLE0101 PLE1310 PLR0911 PLR0915 PLR17 PLE011 PLE13 PLE1206 PLE0604 PLE01 PLE131 PLE010 PLR2004 PLR170 PLR172 PLW PLW060 PLE120 PLE0 PLC04 PLE2502 PLR0913 PLR020 PLE2 PLR0133 PLR040 PLR55 PLE1 PLR550 PLW2 PLR200 PLE12 PLW06 PLE060 PLC3002 PLW2901 PLR0 PLE0605 PLE114 PLC PLW0 PLW0602 PLE0118 PLE06 PLR1 PLR01 PLR013 UP021 UP010 UP011 UP01 UP03 UP025 UP035 UP026 UP030 UP001 UP0 UP007 UP003 UP017 UP022 UP037 UP009 UP038 UP006 UP008 UP023 UP013 UP032 UP004 UP018 UP031 UP00 UP005 UP020 UP029 UP02 UP014 UP012 UP015 UP019 UP024 UP028 UP033 UP034 UP036 UP027 RUF006 RUF00 RUF1 RUF001 RUF100 RUF005 RUF002 RUF10 RUF0 RUF003 TRY20 TRY200 TRY300 TRY201 TRY401 TRY40 TRY004 TRY002 TRY30 TRY00 TRY0 TRY4 TRY2 TRY301 TRY003 TRY400 TRY3" -- "${cur}"))
                    return 0
                    ;;
                --per-file-ignores)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --exclude)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --extend-exclude)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --fixable)
                    COMPREPLY=($(compgen -W "ALL F C90 I N D UP YTT ANN S BLE FBT B A COM C4 DTZ T10 DJ EM EXE ISC ICN G INP PIE T20 PYI PT Q RSE RET SLF SIM TID TCH ARG PTH ERA PD PGH PL TRY NPY RUF ERA0 ERA00 ERA001 YTT10 YTT3 YTT103 YTT203 YTT301 YTT2 YTT20 YTT201 YTT204 YTT303 YTT30 YTT202 YTT102 YTT101 YTT302 YTT1 ANN4 ANN101 ANN00 ANN1 ANN002 ANN201 ANN205 ANN401 ANN206 ANN40 ANN10 ANN001 ANN20 ANN003 ANN0 ANN202 ANN204 ANN2 ANN102 S102 S103 S50 S3 S501 S1 S60 S105 S506 S324 S5 S104 S106 S112 S101 S509 S11 S32 S61 S107 S7 S113 S612 S110 S608 S70 S701 S508 S10 S108 S6 BLE001 BLE0 BLE00 FBT0 FBT001 FBT00 FBT003 FBT002 B023 B014 B025 B01 B020 B007 B027 B904 B013 B018 B905 B9 B0 B032 B02 B008 B009 B024 B03 B026 B022 B019 B005 B00 B003 B011 B021 B90 B010 B004 B017 B012 B016 B002 B006 B015 B029 A00 A0 A001 A003 A002 COM818 COM8 COM819 COM81 COM812 C410 C400 C414 C402 C404 C415 C417 C41 C416 C409 C401 C413 C40 C403 C405 C408 C411 C406 DTZ01 DTZ002 DTZ007 DTZ001 DTZ004 DTZ003 DTZ0 DTZ00 DTZ006 DTZ005 DTZ011 DTZ012 T100 DJ008 DJ001 DJ0 DJ003 DJ007 DJ006 DJ013 DJ00 DJ01 EM102 EM101 EM1 EM103 EM10 EXE003 EXE0 EXE00 EXE002 EXE005 EXE001 EXE004 ISC00 ISC002 ISC001 ISC003 ISC0 ICN00 ICN001 ICN0 G010 G101 G2 G01 G1 G004 G003 G10 G002 G0 G00 G201 G202 G001 G20 INP001 INP0 INP00 PIE807 PIE802 PIE80 PIE796 PIE810 PIE79 PIE7 PIE800 PIE790 PIE794 PIE8 PIE81 PIE804 T203 T201 PYI03 PYI007 PYI021 PYI02 PYI001 PYI006 PYI010 PYI014 PYI0 PYI009 PYI008 PYI033 PYI00 PYI011 PYI01 PT007 PT017 PT023 PT02 PT005 PT010 PT020 PT021 PT024 PT00 PT012 PT003 PT01 PT026 PT008 PT001 PT018 PT006 PT015 PT022 PT002 PT004 PT009 PT013 PT016 PT019 PT025 PT0 PT011 Q003 Q000 Q002 Q0 Q00 Q001 RSE102 RSE1 RSE10 RET50 RET504 RET508 RET501 RET502 RET503 RET505 RET507 RET5 RET506 SLF00 SLF0 SLF001 SIM2 SIM112 SIM201 SIM103 SIM110 SIM115 SIM223 SIM222 SIM109 SIM3 SIM401 SIM102 SIM1 SIM108 SIM210 SIM20 SIM105 SIM107 SIM4 SIM118 SIM116 SIM211 SIM10 SIM40 SIM221 SIM30 SIM114 SIM22 SIM117 SIM208 SIM300 SIM202 SIM21 SIM101 SIM220 SIM212 SIM11 TID251 TID252 TID2 TID25 TCH003 TCH004 TCH002 TCH001 TCH005 TCH0 TCH00 ARG003 ARG0 ARG00 ARG002 ARG005 ARG004 ARG001 PTH116 PTH122 PTH104 PTH110 PTH121 PTH108 PTH123 PTH107 PTH119 PTH10 PTH118 PTH101 PTH114 PTH100 PTH11 PTH102 PTH120 PTH124 PTH1 PTH111 PTH105 PTH113 PTH117 PTH115 PTH103 PTH109 PTH106 PTH12 PTH112 I00 I0 I002 I001 C901 NPY0 NPY00 NPY001 NPY002 N805 N81 N804 N999 N802 N807 N815 N818 N80 N816 N806 N811 N813 N803 N8 N99 N812 N9 N801 N817 N814 PD9 PD015 PD002 PD013 PD01 PD0 PD00 PD901 PD003 PD012 PD008 PD009 PD010 PD007 PD004 PD011 PD90 W292 E7 E73 W5 W6 W60 E40 E402 E71 W29 E702 E501 E99 E713 E10 E50 E70 E72 W293 E742 W291 E9 W19 E711 W2 E731 E401 E721 E74 W1 E1 W605 E703 E714 E902 W505 E4 E90 E E712 W191 E701 E5 E743 W W50 E722 E999 E741 E101 D300 D103 D405 D4 D40 D205 D213 D409 D417 D200 D401 D402 D410 D105 D202 D209 D107 D214 D407 D414 D416 D418 D10 D211 D400 D408 D20 D104 D301 D203 D208 D419 D207 D100 D21 D101 D212 D210 D204 D3 D30 D102 D106 D41 D403 D406 D415 D413 D404 D412 D411 D1 D2 D201 D206 D215 F622 F602 F84 F404 F503 F60 F81 F407 F842 F40 F508 F901 F54 F525 F707 F521 F6 F50 F70 F9 F841 F632 F401 F403 F811 F541 F702 F505 F72 F504 F4 F523 F621 F52 F701 F631 F821 F8 F509 F405 F507 F506 F722 F62 F82 F634 F7 F706 F502 F601 F63 F406 F402 F501 F524 F90 F522 F823 F633 F822 F704 F5 PGH003 PGH002 PGH004 PGH001 PGH0 PGH00 PLR02 PLR2 PLW012 PLR PLR091 PLW0120 PLW0603 PLE1142 PLR0206 PLE PLE1307 PLR1722 PLR5501 PLR04 PLC30 PLE130 PLR5 PLW29 PLE1205 PLR20 PLC300 PLE11 PLW01 PLE0100 PLC3 PLW290 PLC0 PLE0117 PLC0414 PLR0912 PLR1701 PLE25 PLR09 PLR0402 PLC041 PLE250 PLE0101 PLE1310 PLR0911 PLR0915 PLR17 PLE011 PLE13 PLE1206 PLE0604 PLE01 PLE131 PLE010 PLR2004 PLR170 PLR172 PLW PLW060 PLE120 PLE0 PLC04 PLE2502 PLR0913 PLR020 PLE2 PLR0133 PLR040 PLR55 PLE1 PLR550 PLW2 PLR200 PLE12 PLW06 PLE060 PLC3002 PLW2901 PLR0 PLE0605 PLE114 PLC PLW0 PLW0602 PLE0118 PLE06 PLR1 PLR01 PLR013 UP021 UP010 UP011 UP01 UP03 UP025 UP035 UP026 UP030 UP001 UP0 UP007 UP003 UP017 UP022 UP037 UP009 UP038 UP006 UP008 UP023 UP013 UP032 UP004 UP018 UP031 UP00 UP005 UP020 UP029 UP02 UP014 UP012 UP015 UP019 UP024 UP028 UP033 UP034 UP036 UP027 RUF006 RUF00 RUF1 RUF001 RUF100 RUF005 RUF002 RUF10 RUF0 RUF003 TRY20 TRY200 TRY300 TRY201 TRY401 TRY40 TRY004 TRY002 TRY30 TRY00 TRY0 TRY4 TRY2 TRY301 TRY003 TRY400 TRY3" -- "${cur}"))
                    return 0
                    ;;
                --unfixable)
                    COMPREPLY=($(compgen -W "ALL F C90 I N D UP YTT ANN S BLE FBT B A COM C4 DTZ T10 DJ EM EXE ISC ICN G INP PIE T20 PYI PT Q RSE RET SLF SIM TID TCH ARG PTH ERA PD PGH PL TRY NPY RUF ERA0 ERA00 ERA001 YTT10 YTT3 YTT103 YTT203 YTT301 YTT2 YTT20 YTT201 YTT204 YTT303 YTT30 YTT202 YTT102 YTT101 YTT302 YTT1 ANN4 ANN101 ANN00 ANN1 ANN002 ANN201 ANN205 ANN401 ANN206 ANN40 ANN10 ANN001 ANN20 ANN003 ANN0 ANN202 ANN204 ANN2 ANN102 S102 S103 S50 S3 S501 S1 S60 S105 S506 S324 S5 S104 S106 S112 S101 S509 S11 S32 S61 S107 S7 S113 S612 S110 S608 S70 S701 S508 S10 S108 S6 BLE001 BLE0 BLE00 FBT0 FBT001 FBT00 FBT003 FBT002 B023 B014 B025 B01 B020 B007 B027 B904 B013 B018 B905 B9 B0 B032 B02 B008 B009 B024 B03 B026 B022 B019 B005 B00 B003 B011 B021 B90 B010 B004 B017 B012 B016 B002 B006 B015 B029 A00 A0 A001 A003 A002 COM818 COM8 COM819 COM81 COM812 C410 C400 C414 C402 C404 C415 C417 C41 C416 C409 C401 C413 C40 C403 C405 C408 C411 C406 DTZ01 DTZ002 DTZ007 DTZ001 DTZ004 DTZ003 DTZ0 DTZ00 DTZ006 DTZ005 DTZ011 DTZ012 T100 DJ008 DJ001 DJ0 DJ003 DJ007 DJ006 DJ013 DJ00 DJ01 EM102 EM101 EM1 EM103 EM10 EXE003 EXE0 EXE00 EXE002 EXE005 EXE001 EXE004 ISC00 ISC002 ISC001 ISC003 ISC0 ICN00 ICN001 ICN0 G010 G101 G2 G01 G1 G004 G003 G10 G002 G0 G00 G201 G202 G001 G20 INP001 INP0 INP00 PIE807 PIE802 PIE80 PIE796 PIE810 PIE79 PIE7 PIE800 PIE790 PIE794 PIE8 PIE81 PIE804 T203 T201 PYI03 PYI007 PYI021 PYI02 PYI001 PYI006 PYI010 PYI014 PYI0 PYI009 PYI008 PYI033 PYI00 PYI011 PYI01 PT007 PT017 PT023 PT02 PT005 PT010 PT020 PT021 PT024 PT00 PT012 PT003 PT01 PT026 PT008 PT001 PT018 PT006 PT015 PT022 PT002 PT004 PT009 PT013 PT016 PT019 PT025 PT0 PT011 Q003 Q000 Q002 Q0 Q00 Q001 RSE102 RSE1 RSE10 RET50 RET504 RET508 RET501 RET502 RET503 RET505 RET507 RET5 RET506 SLF00 SLF0 SLF001 SIM2 SIM112 SIM201 SIM103 SIM110 SIM115 SIM223 SIM222 SIM109 SIM3 SIM401 SIM102 SIM1 SIM108 SIM210 SIM20 SIM105 SIM107 SIM4 SIM118 SIM116 SIM211 SIM10 SIM40 SIM221 SIM30 SIM114 SIM22 SIM117 SIM208 SIM300 SIM202 SIM21 SIM101 SIM220 SIM212 SIM11 TID251 TID252 TID2 TID25 TCH003 TCH004 TCH002 TCH001 TCH005 TCH0 TCH00 ARG003 ARG0 ARG00 ARG002 ARG005 ARG004 ARG001 PTH116 PTH122 PTH104 PTH110 PTH121 PTH108 PTH123 PTH107 PTH119 PTH10 PTH118 PTH101 PTH114 PTH100 PTH11 PTH102 PTH120 PTH124 PTH1 PTH111 PTH105 PTH113 PTH117 PTH115 PTH103 PTH109 PTH106 PTH12 PTH112 I00 I0 I002 I001 C901 NPY0 NPY00 NPY001 NPY002 N805 N81 N804 N999 N802 N807 N815 N818 N80 N816 N806 N811 N813 N803 N8 N99 N812 N9 N801 N817 N814 PD9 PD015 PD002 PD013 PD01 PD0 PD00 PD901 PD003 PD012 PD008 PD009 PD010 PD007 PD004 PD011 PD90 W292 E7 E73 W5 W6 W60 E40 E402 E71 W29 E702 E501 E99 E713 E10 E50 E70 E72 W293 E742 W291 E9 W19 E711 W2 E731 E401 E721 E74 W1 E1 W605 E703 E714 E902 W505 E4 E90 E E712 W191 E701 E5 E743 W W50 E722 E999 E741 E101 D300 D103 D405 D4 D40 D205 D213 D409 D417 D200 D401 D402 D410 D105 D202 D209 D107 D214 D407 D414 D416 D418 D10 D211 D400 D408 D20 D104 D301 D203 D208 D419 D207 D100 D21 D101 D212 D210 D204 D3 D30 D102 D106 D41 D403 D406 D415 D413 D404 D412 D411 D1 D2 D201 D206 D215 F622 F602 F84 F404 F503 F60 F81 F407 F842 F40 F508 F901 F54 F525 F707 F521 F6 F50 F70 F9 F841 F632 F401 F403 F811 F541 F702 F505 F72 F504 F4 F523 F621 F52 F701 F631 F821 F8 F509 F405 F507 F506 F722 F62 F82 F634 F7 F706 F502 F601 F63 F406 F402 F501 F524 F90 F522 F823 F633 F822 F704 F5 PGH003 PGH002 PGH004 PGH001 PGH0 PGH00 PLR02 PLR2 PLW012 PLR PLR091 PLW0120 PLW0603 PLE1142 PLR0206 PLE PLE1307 PLR1722 PLR5501 PLR04 PLC30 PLE130 PLR5 PLW29 PLE1205 PLR20 PLC300 PLE11 PLW01 PLE0100 PLC3 PLW290 PLC0 PLE0117 PLC0414 PLR0912 PLR1701 PLE25 PLR09 PLR0402 PLC041 PLE250 PLE0101 PLE1310 PLR0911 PLR0915 PLR17 PLE011 PLE13 PLE1206 PLE0604 PLE01 PLE131 PLE010 PLR2004 PLR170 PLR172 PLW PLW060 PLE120 PLE0 PLC04 PLE2502 PLR0913 PLR020 PLE2 PLR0133 PLR040 PLR55 PLE1 PLR550 PLW2 PLR200 PLE12 PLW06 PLE060 PLC3002 PLW2901 PLR0 PLE0605 PLE114 PLC PLW0 PLW0602 PLE0118 PLE06 PLR1 PLR01 PLR013 UP021 UP010 UP011 UP01 UP03 UP025 UP035 UP026 UP030 UP001 UP0 UP007 UP003 UP017 UP022 UP037 UP009 UP038 UP006 UP008 UP023 UP013 UP032 UP004 UP018 UP031 UP00 UP005 UP020 UP029 UP02 UP014 UP012 UP015 UP019 UP024 UP028 UP033 UP034 UP036 UP027 RUF006 RUF00 RUF1 RUF001 RUF100 RUF005 RUF002 RUF10 RUF0 RUF003 TRY20 TRY200 TRY300 TRY201 TRY401 TRY40 TRY004 TRY002 TRY30 TRY00 TRY0 TRY4 TRY2 TRY301 TRY003 TRY400 TRY3" -- "${cur}"))
                    return 0
                    ;;
                --line-length)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --dummy-variable-rgx)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --cache-dir)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --stdin-filename)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__clean)
            opts="-v -q -s -h --verbose --quiet --silent --help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__config)
            opts="-v -q -s -h --verbose --quiet --silent --help [OPTION]"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__generate__shell__completion)
            opts="-v -q -s -h --verbose --quiet --silent --help bash elvish fig fish powershell zsh"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__help)
            opts="check rule config linter clean generate-shell-completion help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__help__check)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__help__clean)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__help__config)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__help__generate__shell__completion)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__help__help)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__help__linter)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__help__rule)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__linter)
            opts="-v -q -s -h --format --verbose --quiet --silent --help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --format)
                    COMPREPLY=($(compgen -W "text json" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        ruff__rule)
            opts="-v -q -s -h --format --verbose --quiet --silent --help <RULE>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --format)
                    COMPREPLY=($(compgen -W "text json" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

complete -F _ruff -o bashdefault -o default ruff
