complete -c ruff -n "__fish_use_subcommand" -s v -l verbose -d 'Enable verbose logging'
complete -c ruff -n "__fish_use_subcommand" -s q -l quiet -d 'Print lint violations, but nothing else'
complete -c ruff -n "__fish_use_subcommand" -s s -l silent -d 'Disable all logging (but still exit with status code "1" upon detecting lint violations)'
complete -c ruff -n "__fish_use_subcommand" -s h -l help -d 'Print help'
complete -c ruff -n "__fish_use_subcommand" -s V -l version -d 'Print version'
complete -c ruff -n "__fish_use_subcommand" -f -a "check" -d 'Run Ruff on the given files or directories (default)'
complete -c ruff -n "__fish_use_subcommand" -f -a "rule" -d 'Explain a rule'
complete -c ruff -n "__fish_use_subcommand" -f -a "config" -d 'List or describe the available configuration options'
complete -c ruff -n "__fish_use_subcommand" -f -a "linter" -d 'List all supported upstream linters'
complete -c ruff -n "__fish_use_subcommand" -f -a "clean" -d 'Clear any caches in the current directory and any subdirectories'
complete -c ruff -n "__fish_use_subcommand" -f -a "generate-shell-completion" -d 'Generate shell completion'
complete -c ruff -n "__fish_use_subcommand" -f -a "help" -d 'Print this message or the help of the given subcommand(s)'
complete -c ruff -n "__fish_seen_subcommand_from check" -l format -d 'Output serialization format for violations' -r -f -a "{text	,json	,junit	,grouped	,github	,gitlab	,pylint	}"
complete -c ruff -n "__fish_seen_subcommand_from check" -l target-version -d 'The minimum Python version that should be supported' -r
complete -c ruff -n "__fish_seen_subcommand_from check" -l config -d 'Path to the `pyproject.toml` or `ruff.toml` file to use for configuration' -r -F
complete -c ruff -n "__fish_seen_subcommand_from check" -l select -d 'Comma-separated list of rule codes to enable (or ALL, to enable all rules)' -r -f -a "{ALL	all rules,F	Pyflakes,C90	mccabe,I	isort,N	pep8-naming,D	pydocstyle,UP	pyupgrade,YTT	flake8-2020,ANN	flake8-annotations,S	flake8-bandit,BLE	flake8-blind-except,FBT	flake8-boolean-trap,B	flake8-bugbear,A	flake8-builtins,COM	flake8-commas,C4	flake8-comprehensions,DTZ	flake8-datetimez,T10	flake8-debugger,DJ	flake8-django,EM	flake8-errmsg,EXE	flake8-executable,ISC	flake8-implicit-str-concat,ICN	flake8-import-conventions,G	flake8-logging-format,INP	flake8-no-pep420,PIE	flake8-pie,T20	flake8-print,PYI	flake8-pyi,PT	flake8-pytest-style,Q	flake8-quotes,RSE	flake8-raise,RET	flake8-return,SLF	flake8-self,SIM	flake8-simplify,TID	flake8-tidy-imports,TCH	flake8-type-checking,ARG	flake8-unused-arguments,PTH	flake8-use-pathlib,ERA	eradicate,PD	pandas-vet,PGH	pygrep-hooks,PL	Pylint,TRY	tryceratops,NPY	NumPy-specific rules,RUF	Ruff-specific rules,ERA0	commented-out-code,ERA00	commented-out-code,ERA001	commented-out-code,YTT10	,YTT3	,YTT103	sys-version-cmp-str3,YTT203	sys-version-info1-cmp-int,YTT301	sys-version0-referenced,YTT2	,YTT20	,YTT201	sys-version-info0-eq3-referenced,YTT204	sys-version-info-minor-cmp-int,YTT303	sys-version-slice1-referenced,YTT30	,YTT202	six-py3-referenced,YTT102	sys-version2-referenced,YTT101	sys-version-slice3-referenced,YTT302	sys-version-cmp-str10,YTT1	,ANN4	any-type,ANN101	missing-type-self,ANN00	,ANN1	,ANN002	missing-type-args,ANN201	missing-return-type-public-function,ANN205	missing-return-type-static-method,ANN401	any-type,ANN206	missing-return-type-class-method,ANN40	any-type,ANN10	,ANN001	missing-type-function-argument,ANN20	,ANN003	missing-type-kwargs,ANN0	,ANN202	missing-return-type-private-function,ANN204	missing-return-type-special-method,ANN2	,ANN102	missing-type-cls,S102	exec-builtin,S103	bad-file-permissions,S50	,S3	hashlib-insecure-hash-function,S501	request-with-no-cert-validation,S1	,S60	hardcoded-sql-expression,S105	hardcoded-password-string,S506	unsafe-yaml-load,S324	hashlib-insecure-hash-function,S5	,S104	hardcoded-bind-all-interfaces,S106	hardcoded-password-func-arg,S112	try-except-continue,S101	assert,S509	snmp-weak-cryptography,S11	,S32	hashlib-insecure-hash-function,S61	logging-config-insecure-listen,S107	hardcoded-password-default,S7	jinja2-autoescape-false,S113	request-without-timeout,S612	logging-config-insecure-listen,S110	try-except-pass,S608	hardcoded-sql-expression,S70	jinja2-autoescape-false,S701	jinja2-autoescape-false,S508	snmp-insecure-version,S10	,S108	hardcoded-temp-file,S6	,BLE001	blind-except,BLE0	blind-except,BLE00	blind-except,FBT0	,FBT001	boolean-positional-arg-in-function-definition,FBT00	,FBT003	boolean-positional-value-in-function-call,FBT002	boolean-default-value-in-function-definition,B023	function-uses-loop-variable,B014	duplicate-handler-exception,B025	duplicate-try-block-exception,B01	,B020	loop-variable-overrides-iterator,B007	unused-loop-control-variable,B027	empty-method-without-abstract-decorator,B904	raise-without-from-inside-except,B013	redundant-tuple-in-exception-handler,B018	useless-expression,B905	zip-without-explicit-strict,B9	,B0	,B032	unintentional-type-annotation,B02	,B008	function-call-argument-default,B009	get-attr-with-constant,B024	abstract-base-class-without-abstract-method,B03	unintentional-type-annotation,B026	star-arg-unpacking-after-keyword-arg,B022	useless-contextlib-suppress,B019	cached-instance-method,B005	strip-with-multi-characters,B00	,B003	assignment-to-os-environ,B011	assert-false,B021	f-string-docstring,B90	,B010	set-attr-with-constant,B004	unreliable-callable-check,B017	assert-raises-exception,B012	jump-statement-in-finally,B016	cannot-raise-literal,B002	unary-prefix-increment,B006	mutable-argument-default,B015	useless-comparison,B029	except-with-empty-tuple,A00	,A0	,A001	builtin-variable-shadowing,A003	builtin-attribute-shadowing,A002	builtin-argument-shadowing,COM818	trailing-comma-on-bare-tuple-prohibited,COM8	,COM819	trailing-comma-prohibited,COM81	,COM812	trailing-comma-missing,C410	unnecessary-literal-within-list-call,C400	unnecessary-generator-list,C414	unnecessary-double-cast-or-process,C402	unnecessary-generator-dict,C404	unnecessary-list-comprehension-dict,C415	unnecessary-subscript-reversal,C417	unnecessary-map,C41	,C416	unnecessary-comprehension,C409	unnecessary-literal-within-tuple-call,C401	unnecessary-generator-set,C413	unnecessary-call-around-sorted,C40	,C403	unnecessary-list-comprehension-set,C405	unnecessary-literal-set,C408	unnecessary-collection-call,C411	unnecessary-list-call,C406	unnecessary-literal-dict,DTZ01	,DTZ002	call-datetime-today,DTZ007	call-datetime-strptime-without-zone,DTZ001	call-datetime-without-tzinfo,DTZ004	call-datetime-utcfromtimestamp,DTZ003	call-datetime-utcnow,DTZ0	,DTZ00	,DTZ006	call-datetime-fromtimestamp,DTZ005	call-datetime-now-without-tzinfo,DTZ011	call-date-today,DTZ012	call-date-fromtimestamp,T100	debugger,DJ008	model-without-dunder-str,DJ001	nullable-model-string-field,DJ0	,DJ003	locals-in-render-function,DJ007	all-with-model-form,DJ006	exclude-with-model-form,DJ013	non-leading-receiver-decorator,DJ00	,DJ01	non-leading-receiver-decorator,EM102	f-string-in-exception,EM101	raw-string-in-exception,EM1	,EM103	dot-format-in-exception,EM10	,EXE003	shebang-python,EXE0	,EXE00	,EXE002	shebang-missing-executable-file,EXE005	shebang-newline,EXE001	shebang-not-executable,EXE004	shebang-whitespace,ISC00	,ISC002	multi-line-implicit-string-concatenation,ISC001	single-line-implicit-string-concatenation,ISC003	explicit-string-concatenation,ISC0	,ICN00	unconventional-import-alias,ICN001	unconventional-import-alias,ICN0	unconventional-import-alias,G010	logging-warn,G101	logging-extra-attr-clash,G2	,G01	logging-warn,G1	logging-extra-attr-clash,G004	logging-f-string,G003	logging-string-concat,G10	logging-extra-attr-clash,G002	logging-percent-format,G0	,G00	,G201	logging-exc-info,G202	logging-redundant-exc-info,G001	logging-string-format,G20	,INP001	implicit-namespace-package,INP0	implicit-namespace-package,INP00	implicit-namespace-package,PIE807	prefer-list-builtin,PIE802	unnecessary-comprehension-any-all,PIE80	,PIE796	prefer-unique-enums,PIE810	single-starts-ends-with,PIE79	,PIE7	,PIE800	unnecessary-spread,PIE790	unnecessary-pass,PIE794	dupe-class-field-definitions,PIE8	,PIE81	single-starts-ends-with,PIE804	unnecessary-dict-kwargs,T203	p-print-found,T201	print-found,PYI03	type-comment-in-stub,PYI007	unrecognized-platform-check,PYI021	docstring-in-stub,PYI02	docstring-in-stub,PYI001	prefix-type-params,PYI006	bad-version-info-comparison,PYI010	non-empty-stub-body,PYI014	argument-simple-defaults,PYI0	,PYI009	pass-statement-stub-body,PYI008	unrecognized-platform-name,PYI033	type-comment-in-stub,PYI00	,PYI011	typed-argument-simple-defaults,PYI01	,PT007	parametrize-values-wrong-type,PT017	assert-in-except,PT023	incorrect-mark-parentheses-style,PT02	,PT005	incorrect-fixture-name-underscore,PT010	raises-without-exception,PT020	deprecated-yield-fixture,PT021	fixture-finalizer-callback,PT024	unnecessary-asyncio-mark-on-fixture,PT00	,PT012	raises-with-multiple-statements,PT003	extraneous-scope-function,PT01	,PT026	use-fixtures-without-parameters,PT008	patch-with-lambda,PT001	incorrect-fixture-parentheses-style,PT018	composite-assertion,PT006	parametrize-names-wrong-type,PT015	assert-always-false,PT022	useless-yield-fixture,PT002	fixture-positional-args,PT004	missing-fixture-name-underscore,PT009	unittest-assertion,PT013	incorrect-pytest-import,PT016	fail-without-message,PT019	fixture-param-without-value,PT025	erroneous-use-fixtures-on-fixture,PT0	,PT011	raises-too-broad,Q003	avoidable-escaped-quote,Q000	bad-quotes-inline-string,Q002	bad-quotes-docstring,Q0	,Q00	,Q001	bad-quotes-multiline-string,RSE102	unnecessary-paren-on-raise-exception,RSE1	unnecessary-paren-on-raise-exception,RSE10	unnecessary-paren-on-raise-exception,RET50	,RET504	unnecessary-assign,RET508	superfluous-else-break,RET501	unnecessary-return-none,RET502	implicit-return-value,RET503	implicit-return,RET505	superfluous-else-return,RET507	superfluous-else-continue,RET5	,RET506	superfluous-else-raise,SLF00	private-member-access,SLF0	private-member-access,SLF001	private-member-access,SIM2	,SIM112	use-capital-environment-variables,SIM201	negate-equal-op,SIM103	needless-bool,SIM110	reimplemented-builtin,SIM115	open-file-with-context-handler,SIM223	expr-and-false,SIM222	expr-or-true,SIM109	compare-with-tuple,SIM3	yoda-conditions,SIM401	dict-get-with-default,SIM102	collapsible-if,SIM1	,SIM108	use-ternary-operator,SIM210	if-expr-with-true-false,SIM20	,SIM105	use-contextlib-suppress,SIM107	return-in-try-except-finally,SIM4	dict-get-with-default,SIM118	key-in-dict,SIM116	manual-dict-lookup,SIM211	if-expr-with-false-true,SIM10	,SIM40	dict-get-with-default,SIM221	expr-or-not-expr,SIM30	yoda-conditions,SIM114	if-with-same-arms,SIM22	,SIM117	multiple-with-statements,SIM208	double-negation,SIM300	yoda-conditions,SIM202	negate-not-equal-op,SIM21	,SIM101	duplicate-isinstance-call,SIM220	expr-and-not-expr,SIM212	if-expr-with-twisted-arms,SIM11	,TID251	banned-api,TID252	relative-imports,TID2	,TID25	,TCH003	typing-only-standard-library-import,TCH004	runtime-import-in-type-checking-block,TCH002	typing-only-third-party-import,TCH001	typing-only-first-party-import,TCH005	empty-type-checking-block,TCH0	,TCH00	,ARG003	unused-class-method-argument,ARG0	,ARG00	,ARG002	unused-method-argument,ARG005	unused-lambda-argument,ARG004	unused-static-method-argument,ARG001	unused-function-argument,PTH116	pathlib-stat,PTH122	pathlib-splitext,PTH104	pathlib-rename,PTH110	pathlib-exists,PTH121	pathlib-samefile,PTH108	pathlib-unlink,PTH123	pathlib-open,PTH107	pathlib-remove,PTH119	pathlib-basename,PTH10	,PTH118	pathlib-join,PTH101	pathlib-chmod,PTH114	pathlib-is-link,PTH100	pathlib-abspath,PTH11	,PTH102	pathlib-mkdir,PTH120	pathlib-dirname,PTH124	pathlib-py-path,PTH1	,PTH111	pathlib-expanduser,PTH105	pathlib-replace,PTH113	pathlib-is-file,PTH117	pathlib-is-abs,PTH115	pathlib-readlink,PTH103	pathlib-makedirs,PTH109	pathlib-getcwd,PTH106	pathlib-rmdir,PTH12	,PTH112	pathlib-is-dir,I00	,I0	,I002	missing-required-import,I001	unsorted-imports,C901	complex-structure,NPY0	,NPY00	,NPY001	numpy-deprecated-type-alias,NPY002	numpy-legacy-random,N805	invalid-first-argument-name-for-method,N81	,N804	invalid-first-argument-name-for-class-method,N999	invalid-module-name,N802	invalid-function-name,N807	dunder-function-name,N815	mixed-case-variable-in-class-scope,N818	error-suffix-on-exception-name,N80	,N816	mixed-case-variable-in-global-scope,N806	non-lowercase-variable-in-function,N811	constant-imported-as-non-constant,N813	camelcase-imported-as-lowercase,N803	invalid-argument-name,N8	,N99	invalid-module-name,N812	lowercase-imported-as-non-lowercase,N9	invalid-module-name,N801	invalid-class-name,N817	camelcase-imported-as-acronym,N814	camelcase-imported-as-constant,PD9	df-is-a-bad-variable-name,PD015	use-of-pd-merge,PD002	use-of-inplace-argument,PD013	use-of-dot-stack,PD01	,PD0	,PD00	,PD901	df-is-a-bad-variable-name,PD003	use-of-dot-is-null,PD012	use-of-dot-read-table,PD008	use-of-dot-at,PD009	use-of-dot-iat,PD010	use-of-dot-pivot-or-unstack,PD007	use-of-dot-ix,PD004	use-of-dot-not-null,PD011	use-of-dot-values,PD90	df-is-a-bad-variable-name,W292	no-new-line-at-end-of-file,E7	,E73	lambda-assignment,W5	doc-line-too-long,W6	invalid-escape-sequence,W60	invalid-escape-sequence,E40	,E402	module-import-not-at-top-of-file,E71	,W29	,E702	multiple-statements-on-one-line-semicolon,E501	line-too-long,E99	syntax-error,E713	not-in-test,E10	mixed-spaces-and-tabs,E50	line-too-long,E70	,E72	,W293	blank-line-contains-whitespace,E742	ambiguous-class-name,W291	trailing-whitespace,E9	,W19	indentation-contains-tabs,E711	none-comparison,W2	,E731	lambda-assignment,E401	multiple-imports-on-one-line,E721	type-comparison,E74	,W1	indentation-contains-tabs,E1	mixed-spaces-and-tabs,W605	invalid-escape-sequence,E703	useless-semicolon,E714	not-is-test,E902	io-error,W505	doc-line-too-long,E4	,E90	io-error,E	,E712	true-false-comparison,W191	indentation-contains-tabs,E701	multiple-statements-on-one-line-colon,E5	line-too-long,E743	ambiguous-function-name,W	,W50	doc-line-too-long,E722	bare-except,E999	syntax-error,E741	ambiguous-variable-name,E101	mixed-spaces-and-tabs,D300	triple-single-quotes,D103	public-function,D405	capitalize-section-name,D4	,D40	,D205	blank-line-after-summary,D213	multi-line-summary-second-line,D409	section-underline-matches-section-length,D417	undocumented-param,D200	fits-on-one-line,D401	non-imperative-mood,D402	no-signature,D410	blank-line-after-section,D105	magic-method,D202	no-blank-line-after-function,D209	new-line-after-last-paragraph,D107	public-init,D214	section-not-over-indented,D407	dashed-underline-after-section,D414	empty-docstring-section,D416	section-name-ends-in-colon,D418	overload-with-docstring,D10	,D211	no-blank-line-before-class,D400	ends-in-period,D408	section-underline-after-name,D20	,D104	public-package,D301	escape-sequence-in-docstring,D203	one-blank-line-before-class,D208	no-over-indentation,D419	empty-docstring,D207	no-under-indentation,D100	public-module,D21	,D101	public-class,D212	multi-line-summary-first-line,D210	no-surrounding-whitespace,D204	one-blank-line-after-class,D3	,D30	,D102	public-method,D106	public-nested-class,D41	,D403	first-line-capitalized,D406	new-line-after-section-name,D415	ends-in-punctuation,D413	blank-line-after-last-section,D404	docstring-starts-with-this,D412	no-blank-lines-between-header-and-content,D411	blank-line-before-section,D1	,D2	,D201	no-blank-line-before-function,D206	indent-with-spaces,D215	section-underline-not-over-indented,F622	two-starred-expressions,F602	multi-value-repeated-key-variable,F84	,F404	late-future-import,F503	percent-format-expected-sequence,F60	,F81	redefined-while-unused,F407	future-feature-not-defined,F842	unused-annotation,F40	,F508	percent-format-star-requires-sequence,F901	raise-not-implemented,F54	f-string-missing-placeholders,F525	string-dot-format-mixing-automatic,F707	default-except-not-last,F521	string-dot-format-invalid-format,F6	,F50	,F70	,F9	raise-not-implemented,F841	unused-variable,F632	is-literal,F401	unused-import,F403	import-star,F811	redefined-while-unused,F541	f-string-missing-placeholders,F702	continue-outside-loop,F505	percent-format-missing-argument,F72	forward-annotation-syntax-error,F504	percent-format-extra-named-arguments,F4	,F523	string-dot-format-extra-positional-arguments,F621	expressions-in-star-assignment,F52	,F701	break-outside-loop,F631	assert-tuple,F821	undefined-name,F8	,F509	percent-format-unsupported-format-character,F405	import-star-usage,F507	percent-format-positional-count-mismatch,F506	percent-format-mixed-positional-and-named,F722	forward-annotation-syntax-error,F62	,F82	,F634	if-tuple,F7	,F706	return-outside-function,F502	percent-format-expected-mapping,F601	multi-value-repeated-key-literal,F63	,F406	import-star-not-permitted,F402	import-shadowed-by-loop-var,F501	percent-format-invalid-format,F524	string-dot-format-missing-arguments,F90	raise-not-implemented,F522	string-dot-format-extra-named-arguments,F823	undefined-local,F633	invalid-print-syntax,F822	undefined-export,F704	yield-outside-function,F5	,PGH003	blanket-type-ignore,PGH002	deprecated-log-warn,PGH004	blanket-noqa,PGH001	no-eval,PGH0	,PGH00	,PLR02	property-with-parameters,PLR2	magic-value-comparison,PLW012	useless-else-on-loop,PLR	,PLR091	,PLW0120	useless-else-on-loop,PLW0603	global-statement,PLE1142	await-outside-async,PLR0206	property-with-parameters,PLE	,PLE1307	bad-string-format-type,PLR1722	consider-using-sys-exit,PLR5501	collapsible-else-if,PLR04	consider-using-from-import,PLC30	unnecessary-direct-lambda-call,PLE130	bad-string-format-type,PLR5	collapsible-else-if,PLW29	redefined-loop-name,PLE1205	logging-too-many-args,PLR20	magic-value-comparison,PLC300	unnecessary-direct-lambda-call,PLE11	await-outside-async,PLW01	useless-else-on-loop,PLE0100	yield-in-init,PLC3	unnecessary-direct-lambda-call,PLW290	redefined-loop-name,PLC0	useless-import-alias,PLE0117	nonlocal-without-binding,PLC0414	useless-import-alias,PLR0912	too-many-branches,PLR1701	consider-merging-isinstance,PLE25	bidirectional-unicode,PLR09	,PLR0402	consider-using-from-import,PLC041	useless-import-alias,PLE250	bidirectional-unicode,PLE0101	return-in-init,PLE1310	bad-str-strip-call,PLR0911	too-many-return-statements,PLR0915	too-many-statements,PLR17	,PLE011	,PLE13	,PLE1206	logging-too-few-args,PLE0604	invalid-all-object,PLE01	,PLE131	bad-str-strip-call,PLE010	,PLR2004	magic-value-comparison,PLR170	consider-merging-isinstance,PLR172	consider-using-sys-exit,PLW	,PLW060	,PLE120	,PLE0	,PLC04	useless-import-alias,PLE2502	bidirectional-unicode,PLR0913	too-many-arguments,PLR020	property-with-parameters,PLE2	bidirectional-unicode,PLR0133	comparison-of-constant,PLR040	consider-using-from-import,PLR55	collapsible-else-if,PLE1	,PLR550	collapsible-else-if,PLW2	redefined-loop-name,PLR200	magic-value-comparison,PLE12	,PLW06	,PLE060	,PLC3002	unnecessary-direct-lambda-call,PLW2901	redefined-loop-name,PLR0	,PLE0605	invalid-all-format,PLE114	await-outside-async,PLC	,PLW0	,PLW0602	global-variable-not-assigned,PLE0118	used-prior-global-declaration,PLE06	,PLR1	,PLR01	comparison-of-constant,PLR013	comparison-of-constant,UP021	replace-universal-newlines,UP010	unnecessary-future-import,UP011	lru-cache-without-parameters,UP01	,UP03	,UP025	rewrite-unicode-literal,UP035	import-replacements,UP026	rewrite-mock-import,UP030	format-literals,UP001	useless-metaclass-type,UP0	,UP007	typing-union,UP003	type-of-primitive,UP017	datetime-timezone-utc,UP022	replace-stdout-stderr,UP037	quoted-annotation,UP009	utf8-encoding-declaration,UP038	isinstance-with-tuple,UP006	deprecated-collection-type,UP008	super-call-with-parameters,UP023	rewrite-c-element-tree,UP013	convert-typed-dict-functional-to-class,UP032	f-string,UP004	useless-object-inheritance,UP018	native-literals,UP031	printf-string-formatting,UP00	,UP005	deprecated-unittest-alias,UP020	open-alias,UP029	unnecessary-builtin-import,UP02	,UP014	convert-named-tuple-functional-to-class,UP012	unnecessary-encode-utf8,UP015	redundant-open-modes,UP019	typing-text-str-alias,UP024	os-error-alias,UP028	rewrite-yield-from,UP033	functools-cache,UP034	extraneous-parentheses,UP036	outdated-version-block,UP027	rewrite-list-comprehension,RUF006	asyncio-dangling-task,RUF00	,RUF1	unused-noqa,RUF001	ambiguous-unicode-character-string,RUF100	unused-noqa,RUF005	unpack-instead-of-concatenating-to-collection-literal,RUF002	ambiguous-unicode-character-docstring,RUF10	unused-noqa,RUF0	,RUF003	ambiguous-unicode-character-comment,TRY20	,TRY200	reraise-no-cause,TRY300	try-consider-else,TRY201	verbose-raise,TRY401	verbose-log-message,TRY40	,TRY004	prefer-type-error,TRY002	raise-vanilla-class,TRY30	,TRY00	,TRY0	,TRY4	,TRY2	,TRY301	raise-within-try,TRY003	raise-vanilla-args,TRY400	error-instead-of-exception,TRY3	}"
complete -c ruff -n "__fish_seen_subcommand_from check" -l ignore -d 'Comma-separated list of rule codes to disable' -r -f -a "{ALL	all rules,F	Pyflakes,C90	mccabe,I	isort,N	pep8-naming,D	pydocstyle,UP	pyupgrade,YTT	flake8-2020,ANN	flake8-annotations,S	flake8-bandit,BLE	flake8-blind-except,FBT	flake8-boolean-trap,B	flake8-bugbear,A	flake8-builtins,COM	flake8-commas,C4	flake8-comprehensions,DTZ	flake8-datetimez,T10	flake8-debugger,DJ	flake8-django,EM	flake8-errmsg,EXE	flake8-executable,ISC	flake8-implicit-str-concat,ICN	flake8-import-conventions,G	flake8-logging-format,INP	flake8-no-pep420,PIE	flake8-pie,T20	flake8-print,PYI	flake8-pyi,PT	flake8-pytest-style,Q	flake8-quotes,RSE	flake8-raise,RET	flake8-return,SLF	flake8-self,SIM	flake8-simplify,TID	flake8-tidy-imports,TCH	flake8-type-checking,ARG	flake8-unused-arguments,PTH	flake8-use-pathlib,ERA	eradicate,PD	pandas-vet,PGH	pygrep-hooks,PL	Pylint,TRY	tryceratops,NPY	NumPy-specific rules,RUF	Ruff-specific rules,ERA0	commented-out-code,ERA00	commented-out-code,ERA001	commented-out-code,YTT10	,YTT3	,YTT103	sys-version-cmp-str3,YTT203	sys-version-info1-cmp-int,YTT301	sys-version0-referenced,YTT2	,YTT20	,YTT201	sys-version-info0-eq3-referenced,YTT204	sys-version-info-minor-cmp-int,YTT303	sys-version-slice1-referenced,YTT30	,YTT202	six-py3-referenced,YTT102	sys-version2-referenced,YTT101	sys-version-slice3-referenced,YTT302	sys-version-cmp-str10,YTT1	,ANN4	any-type,ANN101	missing-type-self,ANN00	,ANN1	,ANN002	missing-type-args,ANN201	missing-return-type-public-function,ANN205	missing-return-type-static-method,ANN401	any-type,ANN206	missing-return-type-class-method,ANN40	any-type,ANN10	,ANN001	missing-type-function-argument,ANN20	,ANN003	missing-type-kwargs,ANN0	,ANN202	missing-return-type-private-function,ANN204	missing-return-type-special-method,ANN2	,ANN102	missing-type-cls,S102	exec-builtin,S103	bad-file-permissions,S50	,S3	hashlib-insecure-hash-function,S501	request-with-no-cert-validation,S1	,S60	hardcoded-sql-expression,S105	hardcoded-password-string,S506	unsafe-yaml-load,S324	hashlib-insecure-hash-function,S5	,S104	hardcoded-bind-all-interfaces,S106	hardcoded-password-func-arg,S112	try-except-continue,S101	assert,S509	snmp-weak-cryptography,S11	,S32	hashlib-insecure-hash-function,S61	logging-config-insecure-listen,S107	hardcoded-password-default,S7	jinja2-autoescape-false,S113	request-without-timeout,S612	logging-config-insecure-listen,S110	try-except-pass,S608	hardcoded-sql-expression,S70	jinja2-autoescape-false,S701	jinja2-autoescape-false,S508	snmp-insecure-version,S10	,S108	hardcoded-temp-file,S6	,BLE001	blind-except,BLE0	blind-except,BLE00	blind-except,FBT0	,FBT001	boolean-positional-arg-in-function-definition,FBT00	,FBT003	boolean-positional-value-in-function-call,FBT002	boolean-default-value-in-function-definition,B023	function-uses-loop-variable,B014	duplicate-handler-exception,B025	duplicate-try-block-exception,B01	,B020	loop-variable-overrides-iterator,B007	unused-loop-control-variable,B027	empty-method-without-abstract-decorator,B904	raise-without-from-inside-except,B013	redundant-tuple-in-exception-handler,B018	useless-expression,B905	zip-without-explicit-strict,B9	,B0	,B032	unintentional-type-annotation,B02	,B008	function-call-argument-default,B009	get-attr-with-constant,B024	abstract-base-class-without-abstract-method,B03	unintentional-type-annotation,B026	star-arg-unpacking-after-keyword-arg,B022	useless-contextlib-suppress,B019	cached-instance-method,B005	strip-with-multi-characters,B00	,B003	assignment-to-os-environ,B011	assert-false,B021	f-string-docstring,B90	,B010	set-attr-with-constant,B004	unreliable-callable-check,B017	assert-raises-exception,B012	jump-statement-in-finally,B016	cannot-raise-literal,B002	unary-prefix-increment,B006	mutable-argument-default,B015	useless-comparison,B029	except-with-empty-tuple,A00	,A0	,A001	builtin-variable-shadowing,A003	builtin-attribute-shadowing,A002	builtin-argument-shadowing,COM818	trailing-comma-on-bare-tuple-prohibited,COM8	,COM819	trailing-comma-prohibited,COM81	,COM812	trailing-comma-missing,C410	unnecessary-literal-within-list-call,C400	unnecessary-generator-list,C414	unnecessary-double-cast-or-process,C402	unnecessary-generator-dict,C404	unnecessary-list-comprehension-dict,C415	unnecessary-subscript-reversal,C417	unnecessary-map,C41	,C416	unnecessary-comprehension,C409	unnecessary-literal-within-tuple-call,C401	unnecessary-generator-set,C413	unnecessary-call-around-sorted,C40	,C403	unnecessary-list-comprehension-set,C405	unnecessary-literal-set,C408	unnecessary-collection-call,C411	unnecessary-list-call,C406	unnecessary-literal-dict,DTZ01	,DTZ002	call-datetime-today,DTZ007	call-datetime-strptime-without-zone,DTZ001	call-datetime-without-tzinfo,DTZ004	call-datetime-utcfromtimestamp,DTZ003	call-datetime-utcnow,DTZ0	,DTZ00	,DTZ006	call-datetime-fromtimestamp,DTZ005	call-datetime-now-without-tzinfo,DTZ011	call-date-today,DTZ012	call-date-fromtimestamp,T100	debugger,DJ008	model-without-dunder-str,DJ001	nullable-model-string-field,DJ0	,DJ003	locals-in-render-function,DJ007	all-with-model-form,DJ006	exclude-with-model-form,DJ013	non-leading-receiver-decorator,DJ00	,DJ01	non-leading-receiver-decorator,EM102	f-string-in-exception,EM101	raw-string-in-exception,EM1	,EM103	dot-format-in-exception,EM10	,EXE003	shebang-python,EXE0	,EXE00	,EXE002	shebang-missing-executable-file,EXE005	shebang-newline,EXE001	shebang-not-executable,EXE004	shebang-whitespace,ISC00	,ISC002	multi-line-implicit-string-concatenation,ISC001	single-line-implicit-string-concatenation,ISC003	explicit-string-concatenation,ISC0	,ICN00	unconventional-import-alias,ICN001	unconventional-import-alias,ICN0	unconventional-import-alias,G010	logging-warn,G101	logging-extra-attr-clash,G2	,G01	logging-warn,G1	logging-extra-attr-clash,G004	logging-f-string,G003	logging-string-concat,G10	logging-extra-attr-clash,G002	logging-percent-format,G0	,G00	,G201	logging-exc-info,G202	logging-redundant-exc-info,G001	logging-string-format,G20	,INP001	implicit-namespace-package,INP0	implicit-namespace-package,INP00	implicit-namespace-package,PIE807	prefer-list-builtin,PIE802	unnecessary-comprehension-any-all,PIE80	,PIE796	prefer-unique-enums,PIE810	single-starts-ends-with,PIE79	,PIE7	,PIE800	unnecessary-spread,PIE790	unnecessary-pass,PIE794	dupe-class-field-definitions,PIE8	,PIE81	single-starts-ends-with,PIE804	unnecessary-dict-kwargs,T203	p-print-found,T201	print-found,PYI03	type-comment-in-stub,PYI007	unrecognized-platform-check,PYI021	docstring-in-stub,PYI02	docstring-in-stub,PYI001	prefix-type-params,PYI006	bad-version-info-comparison,PYI010	non-empty-stub-body,PYI014	argument-simple-defaults,PYI0	,PYI009	pass-statement-stub-body,PYI008	unrecognized-platform-name,PYI033	type-comment-in-stub,PYI00	,PYI011	typed-argument-simple-defaults,PYI01	,PT007	parametrize-values-wrong-type,PT017	assert-in-except,PT023	incorrect-mark-parentheses-style,PT02	,PT005	incorrect-fixture-name-underscore,PT010	raises-without-exception,PT020	deprecated-yield-fixture,PT021	fixture-finalizer-callback,PT024	unnecessary-asyncio-mark-on-fixture,PT00	,PT012	raises-with-multiple-statements,PT003	extraneous-scope-function,PT01	,PT026	use-fixtures-without-parameters,PT008	patch-with-lambda,PT001	incorrect-fixture-parentheses-style,PT018	composite-assertion,PT006	parametrize-names-wrong-type,PT015	assert-always-false,PT022	useless-yield-fixture,PT002	fixture-positional-args,PT004	missing-fixture-name-underscore,PT009	unittest-assertion,PT013	incorrect-pytest-import,PT016	fail-without-message,PT019	fixture-param-without-value,PT025	erroneous-use-fixtures-on-fixture,PT0	,PT011	raises-too-broad,Q003	avoidable-escaped-quote,Q000	bad-quotes-inline-string,Q002	bad-quotes-docstring,Q0	,Q00	,Q001	bad-quotes-multiline-string,RSE102	unnecessary-paren-on-raise-exception,RSE1	unnecessary-paren-on-raise-exception,RSE10	unnecessary-paren-on-raise-exception,RET50	,RET504	unnecessary-assign,RET508	superfluous-else-break,RET501	unnecessary-return-none,RET502	implicit-return-value,RET503	implicit-return,RET505	superfluous-else-return,RET507	superfluous-else-continue,RET5	,RET506	superfluous-else-raise,SLF00	private-member-access,SLF0	private-member-access,SLF001	private-member-access,SIM2	,SIM112	use-capital-environment-variables,SIM201	negate-equal-op,SIM103	needless-bool,SIM110	reimplemented-builtin,SIM115	open-file-with-context-handler,SIM223	expr-and-false,SIM222	expr-or-true,SIM109	compare-with-tuple,SIM3	yoda-conditions,SIM401	dict-get-with-default,SIM102	collapsible-if,SIM1	,SIM108	use-ternary-operator,SIM210	if-expr-with-true-false,SIM20	,SIM105	use-contextlib-suppress,SIM107	return-in-try-except-finally,SIM4	dict-get-with-default,SIM118	key-in-dict,SIM116	manual-dict-lookup,SIM211	if-expr-with-false-true,SIM10	,SIM40	dict-get-with-default,SIM221	expr-or-not-expr,SIM30	yoda-conditions,SIM114	if-with-same-arms,SIM22	,SIM117	multiple-with-statements,SIM208	double-negation,SIM300	yoda-conditions,SIM202	negate-not-equal-op,SIM21	,SIM101	duplicate-isinstance-call,SIM220	expr-and-not-expr,SIM212	if-expr-with-twisted-arms,SIM11	,TID251	banned-api,TID252	relative-imports,TID2	,TID25	,TCH003	typing-only-standard-library-import,TCH004	runtime-import-in-type-checking-block,TCH002	typing-only-third-party-import,TCH001	typing-only-first-party-import,TCH005	empty-type-checking-block,TCH0	,TCH00	,ARG003	unused-class-method-argument,ARG0	,ARG00	,ARG002	unused-method-argument,ARG005	unused-lambda-argument,ARG004	unused-static-method-argument,ARG001	unused-function-argument,PTH116	pathlib-stat,PTH122	pathlib-splitext,PTH104	pathlib-rename,PTH110	pathlib-exists,PTH121	pathlib-samefile,PTH108	pathlib-unlink,PTH123	pathlib-open,PTH107	pathlib-remove,PTH119	pathlib-basename,PTH10	,PTH118	pathlib-join,PTH101	pathlib-chmod,PTH114	pathlib-is-link,PTH100	pathlib-abspath,PTH11	,PTH102	pathlib-mkdir,PTH120	pathlib-dirname,PTH124	pathlib-py-path,PTH1	,PTH111	pathlib-expanduser,PTH105	pathlib-replace,PTH113	pathlib-is-file,PTH117	pathlib-is-abs,PTH115	pathlib-readlink,PTH103	pathlib-makedirs,PTH109	pathlib-getcwd,PTH106	pathlib-rmdir,PTH12	,PTH112	pathlib-is-dir,I00	,I0	,I002	missing-required-import,I001	unsorted-imports,C901	complex-structure,NPY0	,NPY00	,NPY001	numpy-deprecated-type-alias,NPY002	numpy-legacy-random,N805	invalid-first-argument-name-for-method,N81	,N804	invalid-first-argument-name-for-class-method,N999	invalid-module-name,N802	invalid-function-name,N807	dunder-function-name,N815	mixed-case-variable-in-class-scope,N818	error-suffix-on-exception-name,N80	,N816	mixed-case-variable-in-global-scope,N806	non-lowercase-variable-in-function,N811	constant-imported-as-non-constant,N813	camelcase-imported-as-lowercase,N803	invalid-argument-name,N8	,N99	invalid-module-name,N812	lowercase-imported-as-non-lowercase,N9	invalid-module-name,N801	invalid-class-name,N817	camelcase-imported-as-acronym,N814	camelcase-imported-as-constant,PD9	df-is-a-bad-variable-name,PD015	use-of-pd-merge,PD002	use-of-inplace-argument,PD013	use-of-dot-stack,PD01	,PD0	,PD00	,PD901	df-is-a-bad-variable-name,PD003	use-of-dot-is-null,PD012	use-of-dot-read-table,PD008	use-of-dot-at,PD009	use-of-dot-iat,PD010	use-of-dot-pivot-or-unstack,PD007	use-of-dot-ix,PD004	use-of-dot-not-null,PD011	use-of-dot-values,PD90	df-is-a-bad-variable-name,W292	no-new-line-at-end-of-file,E7	,E73	lambda-assignment,W5	doc-line-too-long,W6	invalid-escape-sequence,W60	invalid-escape-sequence,E40	,E402	module-import-not-at-top-of-file,E71	,W29	,E702	multiple-statements-on-one-line-semicolon,E501	line-too-long,E99	syntax-error,E713	not-in-test,E10	mixed-spaces-and-tabs,E50	line-too-long,E70	,E72	,W293	blank-line-contains-whitespace,E742	ambiguous-class-name,W291	trailing-whitespace,E9	,W19	indentation-contains-tabs,E711	none-comparison,W2	,E731	lambda-assignment,E401	multiple-imports-on-one-line,E721	type-comparison,E74	,W1	indentation-contains-tabs,E1	mixed-spaces-and-tabs,W605	invalid-escape-sequence,E703	useless-semicolon,E714	not-is-test,E902	io-error,W505	doc-line-too-long,E4	,E90	io-error,E	,E712	true-false-comparison,W191	indentation-contains-tabs,E701	multiple-statements-on-one-line-colon,E5	line-too-long,E743	ambiguous-function-name,W	,W50	doc-line-too-long,E722	bare-except,E999	syntax-error,E741	ambiguous-variable-name,E101	mixed-spaces-and-tabs,D300	triple-single-quotes,D103	public-function,D405	capitalize-section-name,D4	,D40	,D205	blank-line-after-summary,D213	multi-line-summary-second-line,D409	section-underline-matches-section-length,D417	undocumented-param,D200	fits-on-one-line,D401	non-imperative-mood,D402	no-signature,D410	blank-line-after-section,D105	magic-method,D202	no-blank-line-after-function,D209	new-line-after-last-paragraph,D107	public-init,D214	section-not-over-indented,D407	dashed-underline-after-section,D414	empty-docstring-section,D416	section-name-ends-in-colon,D418	overload-with-docstring,D10	,D211	no-blank-line-before-class,D400	ends-in-period,D408	section-underline-after-name,D20	,D104	public-package,D301	escape-sequence-in-docstring,D203	one-blank-line-before-class,D208	no-over-indentation,D419	empty-docstring,D207	no-under-indentation,D100	public-module,D21	,D101	public-class,D212	multi-line-summary-first-line,D210	no-surrounding-whitespace,D204	one-blank-line-after-class,D3	,D30	,D102	public-method,D106	public-nested-class,D41	,D403	first-line-capitalized,D406	new-line-after-section-name,D415	ends-in-punctuation,D413	blank-line-after-last-section,D404	docstring-starts-with-this,D412	no-blank-lines-between-header-and-content,D411	blank-line-before-section,D1	,D2	,D201	no-blank-line-before-function,D206	indent-with-spaces,D215	section-underline-not-over-indented,F622	two-starred-expressions,F602	multi-value-repeated-key-variable,F84	,F404	late-future-import,F503	percent-format-expected-sequence,F60	,F81	redefined-while-unused,F407	future-feature-not-defined,F842	unused-annotation,F40	,F508	percent-format-star-requires-sequence,F901	raise-not-implemented,F54	f-string-missing-placeholders,F525	string-dot-format-mixing-automatic,F707	default-except-not-last,F521	string-dot-format-invalid-format,F6	,F50	,F70	,F9	raise-not-implemented,F841	unused-variable,F632	is-literal,F401	unused-import,F403	import-star,F811	redefined-while-unused,F541	f-string-missing-placeholders,F702	continue-outside-loop,F505	percent-format-missing-argument,F72	forward-annotation-syntax-error,F504	percent-format-extra-named-arguments,F4	,F523	string-dot-format-extra-positional-arguments,F621	expressions-in-star-assignment,F52	,F701	break-outside-loop,F631	assert-tuple,F821	undefined-name,F8	,F509	percent-format-unsupported-format-character,F405	import-star-usage,F507	percent-format-positional-count-mismatch,F506	percent-format-mixed-positional-and-named,F722	forward-annotation-syntax-error,F62	,F82	,F634	if-tuple,F7	,F706	return-outside-function,F502	percent-format-expected-mapping,F601	multi-value-repeated-key-literal,F63	,F406	import-star-not-permitted,F402	import-shadowed-by-loop-var,F501	percent-format-invalid-format,F524	string-dot-format-missing-arguments,F90	raise-not-implemented,F522	string-dot-format-extra-named-arguments,F823	undefined-local,F633	invalid-print-syntax,F822	undefined-export,F704	yield-outside-function,F5	,PGH003	blanket-type-ignore,PGH002	deprecated-log-warn,PGH004	blanket-noqa,PGH001	no-eval,PGH0	,PGH00	,PLR02	property-with-parameters,PLR2	magic-value-comparison,PLW012	useless-else-on-loop,PLR	,PLR091	,PLW0120	useless-else-on-loop,PLW0603	global-statement,PLE1142	await-outside-async,PLR0206	property-with-parameters,PLE	,PLE1307	bad-string-format-type,PLR1722	consider-using-sys-exit,PLR5501	collapsible-else-if,PLR04	consider-using-from-import,PLC30	unnecessary-direct-lambda-call,PLE130	bad-string-format-type,PLR5	collapsible-else-if,PLW29	redefined-loop-name,PLE1205	logging-too-many-args,PLR20	magic-value-comparison,PLC300	unnecessary-direct-lambda-call,PLE11	await-outside-async,PLW01	useless-else-on-loop,PLE0100	yield-in-init,PLC3	unnecessary-direct-lambda-call,PLW290	redefined-loop-name,PLC0	useless-import-alias,PLE0117	nonlocal-without-binding,PLC0414	useless-import-alias,PLR0912	too-many-branches,PLR1701	consider-merging-isinstance,PLE25	bidirectional-unicode,PLR09	,PLR0402	consider-using-from-import,PLC041	useless-import-alias,PLE250	bidirectional-unicode,PLE0101	return-in-init,PLE1310	bad-str-strip-call,PLR0911	too-many-return-statements,PLR0915	too-many-statements,PLR17	,PLE011	,PLE13	,PLE1206	logging-too-few-args,PLE0604	invalid-all-object,PLE01	,PLE131	bad-str-strip-call,PLE010	,PLR2004	magic-value-comparison,PLR170	consider-merging-isinstance,PLR172	consider-using-sys-exit,PLW	,PLW060	,PLE120	,PLE0	,PLC04	useless-import-alias,PLE2502	bidirectional-unicode,PLR0913	too-many-arguments,PLR020	property-with-parameters,PLE2	bidirectional-unicode,PLR0133	comparison-of-constant,PLR040	consider-using-from-import,PLR55	collapsible-else-if,PLE1	,PLR550	collapsible-else-if,PLW2	redefined-loop-name,PLR200	magic-value-comparison,PLE12	,PLW06	,PLE060	,PLC3002	unnecessary-direct-lambda-call,PLW2901	redefined-loop-name,PLR0	,PLE0605	invalid-all-format,PLE114	await-outside-async,PLC	,PLW0	,PLW0602	global-variable-not-assigned,PLE0118	used-prior-global-declaration,PLE06	,PLR1	,PLR01	comparison-of-constant,PLR013	comparison-of-constant,UP021	replace-universal-newlines,UP010	unnecessary-future-import,UP011	lru-cache-without-parameters,UP01	,UP03	,UP025	rewrite-unicode-literal,UP035	import-replacements,UP026	rewrite-mock-import,UP030	format-literals,UP001	useless-metaclass-type,UP0	,UP007	typing-union,UP003	type-of-primitive,UP017	datetime-timezone-utc,UP022	replace-stdout-stderr,UP037	quoted-annotation,UP009	utf8-encoding-declaration,UP038	isinstance-with-tuple,UP006	deprecated-collection-type,UP008	super-call-with-parameters,UP023	rewrite-c-element-tree,UP013	convert-typed-dict-functional-to-class,UP032	f-string,UP004	useless-object-inheritance,UP018	native-literals,UP031	printf-string-formatting,UP00	,UP005	deprecated-unittest-alias,UP020	open-alias,UP029	unnecessary-builtin-import,UP02	,UP014	convert-named-tuple-functional-to-class,UP012	unnecessary-encode-utf8,UP015	redundant-open-modes,UP019	typing-text-str-alias,UP024	os-error-alias,UP028	rewrite-yield-from,UP033	functools-cache,UP034	extraneous-parentheses,UP036	outdated-version-block,UP027	rewrite-list-comprehension,RUF006	asyncio-dangling-task,RUF00	,RUF1	unused-noqa,RUF001	ambiguous-unicode-character-string,RUF100	unused-noqa,RUF005	unpack-instead-of-concatenating-to-collection-literal,RUF002	ambiguous-unicode-character-docstring,RUF10	unused-noqa,RUF0	,RUF003	ambiguous-unicode-character-comment,TRY20	,TRY200	reraise-no-cause,TRY300	try-consider-else,TRY201	verbose-raise,TRY401	verbose-log-message,TRY40	,TRY004	prefer-type-error,TRY002	raise-vanilla-class,TRY30	,TRY00	,TRY0	,TRY4	,TRY2	,TRY301	raise-within-try,TRY003	raise-vanilla-args,TRY400	error-instead-of-exception,TRY3	}"
complete -c ruff -n "__fish_seen_subcommand_from check" -l extend-select -d 'Like --select, but adds additional rule codes on top of the selected ones' -r -f -a "{ALL	all rules,F	Pyflakes,C90	mccabe,I	isort,N	pep8-naming,D	pydocstyle,UP	pyupgrade,YTT	flake8-2020,ANN	flake8-annotations,S	flake8-bandit,BLE	flake8-blind-except,FBT	flake8-boolean-trap,B	flake8-bugbear,A	flake8-builtins,COM	flake8-commas,C4	flake8-comprehensions,DTZ	flake8-datetimez,T10	flake8-debugger,DJ	flake8-django,EM	flake8-errmsg,EXE	flake8-executable,ISC	flake8-implicit-str-concat,ICN	flake8-import-conventions,G	flake8-logging-format,INP	flake8-no-pep420,PIE	flake8-pie,T20	flake8-print,PYI	flake8-pyi,PT	flake8-pytest-style,Q	flake8-quotes,RSE	flake8-raise,RET	flake8-return,SLF	flake8-self,SIM	flake8-simplify,TID	flake8-tidy-imports,TCH	flake8-type-checking,ARG	flake8-unused-arguments,PTH	flake8-use-pathlib,ERA	eradicate,PD	pandas-vet,PGH	pygrep-hooks,PL	Pylint,TRY	tryceratops,NPY	NumPy-specific rules,RUF	Ruff-specific rules,ERA0	commented-out-code,ERA00	commented-out-code,ERA001	commented-out-code,YTT10	,YTT3	,YTT103	sys-version-cmp-str3,YTT203	sys-version-info1-cmp-int,YTT301	sys-version0-referenced,YTT2	,YTT20	,YTT201	sys-version-info0-eq3-referenced,YTT204	sys-version-info-minor-cmp-int,YTT303	sys-version-slice1-referenced,YTT30	,YTT202	six-py3-referenced,YTT102	sys-version2-referenced,YTT101	sys-version-slice3-referenced,YTT302	sys-version-cmp-str10,YTT1	,ANN4	any-type,ANN101	missing-type-self,ANN00	,ANN1	,ANN002	missing-type-args,ANN201	missing-return-type-public-function,ANN205	missing-return-type-static-method,ANN401	any-type,ANN206	missing-return-type-class-method,ANN40	any-type,ANN10	,ANN001	missing-type-function-argument,ANN20	,ANN003	missing-type-kwargs,ANN0	,ANN202	missing-return-type-private-function,ANN204	missing-return-type-special-method,ANN2	,ANN102	missing-type-cls,S102	exec-builtin,S103	bad-file-permissions,S50	,S3	hashlib-insecure-hash-function,S501	request-with-no-cert-validation,S1	,S60	hardcoded-sql-expression,S105	hardcoded-password-string,S506	unsafe-yaml-load,S324	hashlib-insecure-hash-function,S5	,S104	hardcoded-bind-all-interfaces,S106	hardcoded-password-func-arg,S112	try-except-continue,S101	assert,S509	snmp-weak-cryptography,S11	,S32	hashlib-insecure-hash-function,S61	logging-config-insecure-listen,S107	hardcoded-password-default,S7	jinja2-autoescape-false,S113	request-without-timeout,S612	logging-config-insecure-listen,S110	try-except-pass,S608	hardcoded-sql-expression,S70	jinja2-autoescape-false,S701	jinja2-autoescape-false,S508	snmp-insecure-version,S10	,S108	hardcoded-temp-file,S6	,BLE001	blind-except,BLE0	blind-except,BLE00	blind-except,FBT0	,FBT001	boolean-positional-arg-in-function-definition,FBT00	,FBT003	boolean-positional-value-in-function-call,FBT002	boolean-default-value-in-function-definition,B023	function-uses-loop-variable,B014	duplicate-handler-exception,B025	duplicate-try-block-exception,B01	,B020	loop-variable-overrides-iterator,B007	unused-loop-control-variable,B027	empty-method-without-abstract-decorator,B904	raise-without-from-inside-except,B013	redundant-tuple-in-exception-handler,B018	useless-expression,B905	zip-without-explicit-strict,B9	,B0	,B032	unintentional-type-annotation,B02	,B008	function-call-argument-default,B009	get-attr-with-constant,B024	abstract-base-class-without-abstract-method,B03	unintentional-type-annotation,B026	star-arg-unpacking-after-keyword-arg,B022	useless-contextlib-suppress,B019	cached-instance-method,B005	strip-with-multi-characters,B00	,B003	assignment-to-os-environ,B011	assert-false,B021	f-string-docstring,B90	,B010	set-attr-with-constant,B004	unreliable-callable-check,B017	assert-raises-exception,B012	jump-statement-in-finally,B016	cannot-raise-literal,B002	unary-prefix-increment,B006	mutable-argument-default,B015	useless-comparison,B029	except-with-empty-tuple,A00	,A0	,A001	builtin-variable-shadowing,A003	builtin-attribute-shadowing,A002	builtin-argument-shadowing,COM818	trailing-comma-on-bare-tuple-prohibited,COM8	,COM819	trailing-comma-prohibited,COM81	,COM812	trailing-comma-missing,C410	unnecessary-literal-within-list-call,C400	unnecessary-generator-list,C414	unnecessary-double-cast-or-process,C402	unnecessary-generator-dict,C404	unnecessary-list-comprehension-dict,C415	unnecessary-subscript-reversal,C417	unnecessary-map,C41	,C416	unnecessary-comprehension,C409	unnecessary-literal-within-tuple-call,C401	unnecessary-generator-set,C413	unnecessary-call-around-sorted,C40	,C403	unnecessary-list-comprehension-set,C405	unnecessary-literal-set,C408	unnecessary-collection-call,C411	unnecessary-list-call,C406	unnecessary-literal-dict,DTZ01	,DTZ002	call-datetime-today,DTZ007	call-datetime-strptime-without-zone,DTZ001	call-datetime-without-tzinfo,DTZ004	call-datetime-utcfromtimestamp,DTZ003	call-datetime-utcnow,DTZ0	,DTZ00	,DTZ006	call-datetime-fromtimestamp,DTZ005	call-datetime-now-without-tzinfo,DTZ011	call-date-today,DTZ012	call-date-fromtimestamp,T100	debugger,DJ008	model-without-dunder-str,DJ001	nullable-model-string-field,DJ0	,DJ003	locals-in-render-function,DJ007	all-with-model-form,DJ006	exclude-with-model-form,DJ013	non-leading-receiver-decorator,DJ00	,DJ01	non-leading-receiver-decorator,EM102	f-string-in-exception,EM101	raw-string-in-exception,EM1	,EM103	dot-format-in-exception,EM10	,EXE003	shebang-python,EXE0	,EXE00	,EXE002	shebang-missing-executable-file,EXE005	shebang-newline,EXE001	shebang-not-executable,EXE004	shebang-whitespace,ISC00	,ISC002	multi-line-implicit-string-concatenation,ISC001	single-line-implicit-string-concatenation,ISC003	explicit-string-concatenation,ISC0	,ICN00	unconventional-import-alias,ICN001	unconventional-import-alias,ICN0	unconventional-import-alias,G010	logging-warn,G101	logging-extra-attr-clash,G2	,G01	logging-warn,G1	logging-extra-attr-clash,G004	logging-f-string,G003	logging-string-concat,G10	logging-extra-attr-clash,G002	logging-percent-format,G0	,G00	,G201	logging-exc-info,G202	logging-redundant-exc-info,G001	logging-string-format,G20	,INP001	implicit-namespace-package,INP0	implicit-namespace-package,INP00	implicit-namespace-package,PIE807	prefer-list-builtin,PIE802	unnecessary-comprehension-any-all,PIE80	,PIE796	prefer-unique-enums,PIE810	single-starts-ends-with,PIE79	,PIE7	,PIE800	unnecessary-spread,PIE790	unnecessary-pass,PIE794	dupe-class-field-definitions,PIE8	,PIE81	single-starts-ends-with,PIE804	unnecessary-dict-kwargs,T203	p-print-found,T201	print-found,PYI03	type-comment-in-stub,PYI007	unrecognized-platform-check,PYI021	docstring-in-stub,PYI02	docstring-in-stub,PYI001	prefix-type-params,PYI006	bad-version-info-comparison,PYI010	non-empty-stub-body,PYI014	argument-simple-defaults,PYI0	,PYI009	pass-statement-stub-body,PYI008	unrecognized-platform-name,PYI033	type-comment-in-stub,PYI00	,PYI011	typed-argument-simple-defaults,PYI01	,PT007	parametrize-values-wrong-type,PT017	assert-in-except,PT023	incorrect-mark-parentheses-style,PT02	,PT005	incorrect-fixture-name-underscore,PT010	raises-without-exception,PT020	deprecated-yield-fixture,PT021	fixture-finalizer-callback,PT024	unnecessary-asyncio-mark-on-fixture,PT00	,PT012	raises-with-multiple-statements,PT003	extraneous-scope-function,PT01	,PT026	use-fixtures-without-parameters,PT008	patch-with-lambda,PT001	incorrect-fixture-parentheses-style,PT018	composite-assertion,PT006	parametrize-names-wrong-type,PT015	assert-always-false,PT022	useless-yield-fixture,PT002	fixture-positional-args,PT004	missing-fixture-name-underscore,PT009	unittest-assertion,PT013	incorrect-pytest-import,PT016	fail-without-message,PT019	fixture-param-without-value,PT025	erroneous-use-fixtures-on-fixture,PT0	,PT011	raises-too-broad,Q003	avoidable-escaped-quote,Q000	bad-quotes-inline-string,Q002	bad-quotes-docstring,Q0	,Q00	,Q001	bad-quotes-multiline-string,RSE102	unnecessary-paren-on-raise-exception,RSE1	unnecessary-paren-on-raise-exception,RSE10	unnecessary-paren-on-raise-exception,RET50	,RET504	unnecessary-assign,RET508	superfluous-else-break,RET501	unnecessary-return-none,RET502	implicit-return-value,RET503	implicit-return,RET505	superfluous-else-return,RET507	superfluous-else-continue,RET5	,RET506	superfluous-else-raise,SLF00	private-member-access,SLF0	private-member-access,SLF001	private-member-access,SIM2	,SIM112	use-capital-environment-variables,SIM201	negate-equal-op,SIM103	needless-bool,SIM110	reimplemented-builtin,SIM115	open-file-with-context-handler,SIM223	expr-and-false,SIM222	expr-or-true,SIM109	compare-with-tuple,SIM3	yoda-conditions,SIM401	dict-get-with-default,SIM102	collapsible-if,SIM1	,SIM108	use-ternary-operator,SIM210	if-expr-with-true-false,SIM20	,SIM105	use-contextlib-suppress,SIM107	return-in-try-except-finally,SIM4	dict-get-with-default,SIM118	key-in-dict,SIM116	manual-dict-lookup,SIM211	if-expr-with-false-true,SIM10	,SIM40	dict-get-with-default,SIM221	expr-or-not-expr,SIM30	yoda-conditions,SIM114	if-with-same-arms,SIM22	,SIM117	multiple-with-statements,SIM208	double-negation,SIM300	yoda-conditions,SIM202	negate-not-equal-op,SIM21	,SIM101	duplicate-isinstance-call,SIM220	expr-and-not-expr,SIM212	if-expr-with-twisted-arms,SIM11	,TID251	banned-api,TID252	relative-imports,TID2	,TID25	,TCH003	typing-only-standard-library-import,TCH004	runtime-import-in-type-checking-block,TCH002	typing-only-third-party-import,TCH001	typing-only-first-party-import,TCH005	empty-type-checking-block,TCH0	,TCH00	,ARG003	unused-class-method-argument,ARG0	,ARG00	,ARG002	unused-method-argument,ARG005	unused-lambda-argument,ARG004	unused-static-method-argument,ARG001	unused-function-argument,PTH116	pathlib-stat,PTH122	pathlib-splitext,PTH104	pathlib-rename,PTH110	pathlib-exists,PTH121	pathlib-samefile,PTH108	pathlib-unlink,PTH123	pathlib-open,PTH107	pathlib-remove,PTH119	pathlib-basename,PTH10	,PTH118	pathlib-join,PTH101	pathlib-chmod,PTH114	pathlib-is-link,PTH100	pathlib-abspath,PTH11	,PTH102	pathlib-mkdir,PTH120	pathlib-dirname,PTH124	pathlib-py-path,PTH1	,PTH111	pathlib-expanduser,PTH105	pathlib-replace,PTH113	pathlib-is-file,PTH117	pathlib-is-abs,PTH115	pathlib-readlink,PTH103	pathlib-makedirs,PTH109	pathlib-getcwd,PTH106	pathlib-rmdir,PTH12	,PTH112	pathlib-is-dir,I00	,I0	,I002	missing-required-import,I001	unsorted-imports,C901	complex-structure,NPY0	,NPY00	,NPY001	numpy-deprecated-type-alias,NPY002	numpy-legacy-random,N805	invalid-first-argument-name-for-method,N81	,N804	invalid-first-argument-name-for-class-method,N999	invalid-module-name,N802	invalid-function-name,N807	dunder-function-name,N815	mixed-case-variable-in-class-scope,N818	error-suffix-on-exception-name,N80	,N816	mixed-case-variable-in-global-scope,N806	non-lowercase-variable-in-function,N811	constant-imported-as-non-constant,N813	camelcase-imported-as-lowercase,N803	invalid-argument-name,N8	,N99	invalid-module-name,N812	lowercase-imported-as-non-lowercase,N9	invalid-module-name,N801	invalid-class-name,N817	camelcase-imported-as-acronym,N814	camelcase-imported-as-constant,PD9	df-is-a-bad-variable-name,PD015	use-of-pd-merge,PD002	use-of-inplace-argument,PD013	use-of-dot-stack,PD01	,PD0	,PD00	,PD901	df-is-a-bad-variable-name,PD003	use-of-dot-is-null,PD012	use-of-dot-read-table,PD008	use-of-dot-at,PD009	use-of-dot-iat,PD010	use-of-dot-pivot-or-unstack,PD007	use-of-dot-ix,PD004	use-of-dot-not-null,PD011	use-of-dot-values,PD90	df-is-a-bad-variable-name,W292	no-new-line-at-end-of-file,E7	,E73	lambda-assignment,W5	doc-line-too-long,W6	invalid-escape-sequence,W60	invalid-escape-sequence,E40	,E402	module-import-not-at-top-of-file,E71	,W29	,E702	multiple-statements-on-one-line-semicolon,E501	line-too-long,E99	syntax-error,E713	not-in-test,E10	mixed-spaces-and-tabs,E50	line-too-long,E70	,E72	,W293	blank-line-contains-whitespace,E742	ambiguous-class-name,W291	trailing-whitespace,E9	,W19	indentation-contains-tabs,E711	none-comparison,W2	,E731	lambda-assignment,E401	multiple-imports-on-one-line,E721	type-comparison,E74	,W1	indentation-contains-tabs,E1	mixed-spaces-and-tabs,W605	invalid-escape-sequence,E703	useless-semicolon,E714	not-is-test,E902	io-error,W505	doc-line-too-long,E4	,E90	io-error,E	,E712	true-false-comparison,W191	indentation-contains-tabs,E701	multiple-statements-on-one-line-colon,E5	line-too-long,E743	ambiguous-function-name,W	,W50	doc-line-too-long,E722	bare-except,E999	syntax-error,E741	ambiguous-variable-name,E101	mixed-spaces-and-tabs,D300	triple-single-quotes,D103	public-function,D405	capitalize-section-name,D4	,D40	,D205	blank-line-after-summary,D213	multi-line-summary-second-line,D409	section-underline-matches-section-length,D417	undocumented-param,D200	fits-on-one-line,D401	non-imperative-mood,D402	no-signature,D410	blank-line-after-section,D105	magic-method,D202	no-blank-line-after-function,D209	new-line-after-last-paragraph,D107	public-init,D214	section-not-over-indented,D407	dashed-underline-after-section,D414	empty-docstring-section,D416	section-name-ends-in-colon,D418	overload-with-docstring,D10	,D211	no-blank-line-before-class,D400	ends-in-period,D408	section-underline-after-name,D20	,D104	public-package,D301	escape-sequence-in-docstring,D203	one-blank-line-before-class,D208	no-over-indentation,D419	empty-docstring,D207	no-under-indentation,D100	public-module,D21	,D101	public-class,D212	multi-line-summary-first-line,D210	no-surrounding-whitespace,D204	one-blank-line-after-class,D3	,D30	,D102	public-method,D106	public-nested-class,D41	,D403	first-line-capitalized,D406	new-line-after-section-name,D415	ends-in-punctuation,D413	blank-line-after-last-section,D404	docstring-starts-with-this,D412	no-blank-lines-between-header-and-content,D411	blank-line-before-section,D1	,D2	,D201	no-blank-line-before-function,D206	indent-with-spaces,D215	section-underline-not-over-indented,F622	two-starred-expressions,F602	multi-value-repeated-key-variable,F84	,F404	late-future-import,F503	percent-format-expected-sequence,F60	,F81	redefined-while-unused,F407	future-feature-not-defined,F842	unused-annotation,F40	,F508	percent-format-star-requires-sequence,F901	raise-not-implemented,F54	f-string-missing-placeholders,F525	string-dot-format-mixing-automatic,F707	default-except-not-last,F521	string-dot-format-invalid-format,F6	,F50	,F70	,F9	raise-not-implemented,F841	unused-variable,F632	is-literal,F401	unused-import,F403	import-star,F811	redefined-while-unused,F541	f-string-missing-placeholders,F702	continue-outside-loop,F505	percent-format-missing-argument,F72	forward-annotation-syntax-error,F504	percent-format-extra-named-arguments,F4	,F523	string-dot-format-extra-positional-arguments,F621	expressions-in-star-assignment,F52	,F701	break-outside-loop,F631	assert-tuple,F821	undefined-name,F8	,F509	percent-format-unsupported-format-character,F405	import-star-usage,F507	percent-format-positional-count-mismatch,F506	percent-format-mixed-positional-and-named,F722	forward-annotation-syntax-error,F62	,F82	,F634	if-tuple,F7	,F706	return-outside-function,F502	percent-format-expected-mapping,F601	multi-value-repeated-key-literal,F63	,F406	import-star-not-permitted,F402	import-shadowed-by-loop-var,F501	percent-format-invalid-format,F524	string-dot-format-missing-arguments,F90	raise-not-implemented,F522	string-dot-format-extra-named-arguments,F823	undefined-local,F633	invalid-print-syntax,F822	undefined-export,F704	yield-outside-function,F5	,PGH003	blanket-type-ignore,PGH002	deprecated-log-warn,PGH004	blanket-noqa,PGH001	no-eval,PGH0	,PGH00	,PLR02	property-with-parameters,PLR2	magic-value-comparison,PLW012	useless-else-on-loop,PLR	,PLR091	,PLW0120	useless-else-on-loop,PLW0603	global-statement,PLE1142	await-outside-async,PLR0206	property-with-parameters,PLE	,PLE1307	bad-string-format-type,PLR1722	consider-using-sys-exit,PLR5501	collapsible-else-if,PLR04	consider-using-from-import,PLC30	unnecessary-direct-lambda-call,PLE130	bad-string-format-type,PLR5	collapsible-else-if,PLW29	redefined-loop-name,PLE1205	logging-too-many-args,PLR20	magic-value-comparison,PLC300	unnecessary-direct-lambda-call,PLE11	await-outside-async,PLW01	useless-else-on-loop,PLE0100	yield-in-init,PLC3	unnecessary-direct-lambda-call,PLW290	redefined-loop-name,PLC0	useless-import-alias,PLE0117	nonlocal-without-binding,PLC0414	useless-import-alias,PLR0912	too-many-branches,PLR1701	consider-merging-isinstance,PLE25	bidirectional-unicode,PLR09	,PLR0402	consider-using-from-import,PLC041	useless-import-alias,PLE250	bidirectional-unicode,PLE0101	return-in-init,PLE1310	bad-str-strip-call,PLR0911	too-many-return-statements,PLR0915	too-many-statements,PLR17	,PLE011	,PLE13	,PLE1206	logging-too-few-args,PLE0604	invalid-all-object,PLE01	,PLE131	bad-str-strip-call,PLE010	,PLR2004	magic-value-comparison,PLR170	consider-merging-isinstance,PLR172	consider-using-sys-exit,PLW	,PLW060	,PLE120	,PLE0	,PLC04	useless-import-alias,PLE2502	bidirectional-unicode,PLR0913	too-many-arguments,PLR020	property-with-parameters,PLE2	bidirectional-unicode,PLR0133	comparison-of-constant,PLR040	consider-using-from-import,PLR55	collapsible-else-if,PLE1	,PLR550	collapsible-else-if,PLW2	redefined-loop-name,PLR200	magic-value-comparison,PLE12	,PLW06	,PLE060	,PLC3002	unnecessary-direct-lambda-call,PLW2901	redefined-loop-name,PLR0	,PLE0605	invalid-all-format,PLE114	await-outside-async,PLC	,PLW0	,PLW0602	global-variable-not-assigned,PLE0118	used-prior-global-declaration,PLE06	,PLR1	,PLR01	comparison-of-constant,PLR013	comparison-of-constant,UP021	replace-universal-newlines,UP010	unnecessary-future-import,UP011	lru-cache-without-parameters,UP01	,UP03	,UP025	rewrite-unicode-literal,UP035	import-replacements,UP026	rewrite-mock-import,UP030	format-literals,UP001	useless-metaclass-type,UP0	,UP007	typing-union,UP003	type-of-primitive,UP017	datetime-timezone-utc,UP022	replace-stdout-stderr,UP037	quoted-annotation,UP009	utf8-encoding-declaration,UP038	isinstance-with-tuple,UP006	deprecated-collection-type,UP008	super-call-with-parameters,UP023	rewrite-c-element-tree,UP013	convert-typed-dict-functional-to-class,UP032	f-string,UP004	useless-object-inheritance,UP018	native-literals,UP031	printf-string-formatting,UP00	,UP005	deprecated-unittest-alias,UP020	open-alias,UP029	unnecessary-builtin-import,UP02	,UP014	convert-named-tuple-functional-to-class,UP012	unnecessary-encode-utf8,UP015	redundant-open-modes,UP019	typing-text-str-alias,UP024	os-error-alias,UP028	rewrite-yield-from,UP033	functools-cache,UP034	extraneous-parentheses,UP036	outdated-version-block,UP027	rewrite-list-comprehension,RUF006	asyncio-dangling-task,RUF00	,RUF1	unused-noqa,RUF001	ambiguous-unicode-character-string,RUF100	unused-noqa,RUF005	unpack-instead-of-concatenating-to-collection-literal,RUF002	ambiguous-unicode-character-docstring,RUF10	unused-noqa,RUF0	,RUF003	ambiguous-unicode-character-comment,TRY20	,TRY200	reraise-no-cause,TRY300	try-consider-else,TRY201	verbose-raise,TRY401	verbose-log-message,TRY40	,TRY004	prefer-type-error,TRY002	raise-vanilla-class,TRY30	,TRY00	,TRY0	,TRY4	,TRY2	,TRY301	raise-within-try,TRY003	raise-vanilla-args,TRY400	error-instead-of-exception,TRY3	}"
complete -c ruff -n "__fish_seen_subcommand_from check" -l extend-ignore -d 'Like --ignore. (Deprecated: You can just use --ignore instead.)' -r -f -a "{ALL	all rules,F	Pyflakes,C90	mccabe,I	isort,N	pep8-naming,D	pydocstyle,UP	pyupgrade,YTT	flake8-2020,ANN	flake8-annotations,S	flake8-bandit,BLE	flake8-blind-except,FBT	flake8-boolean-trap,B	flake8-bugbear,A	flake8-builtins,COM	flake8-commas,C4	flake8-comprehensions,DTZ	flake8-datetimez,T10	flake8-debugger,DJ	flake8-django,EM	flake8-errmsg,EXE	flake8-executable,ISC	flake8-implicit-str-concat,ICN	flake8-import-conventions,G	flake8-logging-format,INP	flake8-no-pep420,PIE	flake8-pie,T20	flake8-print,PYI	flake8-pyi,PT	flake8-pytest-style,Q	flake8-quotes,RSE	flake8-raise,RET	flake8-return,SLF	flake8-self,SIM	flake8-simplify,TID	flake8-tidy-imports,TCH	flake8-type-checking,ARG	flake8-unused-arguments,PTH	flake8-use-pathlib,ERA	eradicate,PD	pandas-vet,PGH	pygrep-hooks,PL	Pylint,TRY	tryceratops,NPY	NumPy-specific rules,RUF	Ruff-specific rules,ERA0	commented-out-code,ERA00	commented-out-code,ERA001	commented-out-code,YTT10	,YTT3	,YTT103	sys-version-cmp-str3,YTT203	sys-version-info1-cmp-int,YTT301	sys-version0-referenced,YTT2	,YTT20	,YTT201	sys-version-info0-eq3-referenced,YTT204	sys-version-info-minor-cmp-int,YTT303	sys-version-slice1-referenced,YTT30	,YTT202	six-py3-referenced,YTT102	sys-version2-referenced,YTT101	sys-version-slice3-referenced,YTT302	sys-version-cmp-str10,YTT1	,ANN4	any-type,ANN101	missing-type-self,ANN00	,ANN1	,ANN002	missing-type-args,ANN201	missing-return-type-public-function,ANN205	missing-return-type-static-method,ANN401	any-type,ANN206	missing-return-type-class-method,ANN40	any-type,ANN10	,ANN001	missing-type-function-argument,ANN20	,ANN003	missing-type-kwargs,ANN0	,ANN202	missing-return-type-private-function,ANN204	missing-return-type-special-method,ANN2	,ANN102	missing-type-cls,S102	exec-builtin,S103	bad-file-permissions,S50	,S3	hashlib-insecure-hash-function,S501	request-with-no-cert-validation,S1	,S60	hardcoded-sql-expression,S105	hardcoded-password-string,S506	unsafe-yaml-load,S324	hashlib-insecure-hash-function,S5	,S104	hardcoded-bind-all-interfaces,S106	hardcoded-password-func-arg,S112	try-except-continue,S101	assert,S509	snmp-weak-cryptography,S11	,S32	hashlib-insecure-hash-function,S61	logging-config-insecure-listen,S107	hardcoded-password-default,S7	jinja2-autoescape-false,S113	request-without-timeout,S612	logging-config-insecure-listen,S110	try-except-pass,S608	hardcoded-sql-expression,S70	jinja2-autoescape-false,S701	jinja2-autoescape-false,S508	snmp-insecure-version,S10	,S108	hardcoded-temp-file,S6	,BLE001	blind-except,BLE0	blind-except,BLE00	blind-except,FBT0	,FBT001	boolean-positional-arg-in-function-definition,FBT00	,FBT003	boolean-positional-value-in-function-call,FBT002	boolean-default-value-in-function-definition,B023	function-uses-loop-variable,B014	duplicate-handler-exception,B025	duplicate-try-block-exception,B01	,B020	loop-variable-overrides-iterator,B007	unused-loop-control-variable,B027	empty-method-without-abstract-decorator,B904	raise-without-from-inside-except,B013	redundant-tuple-in-exception-handler,B018	useless-expression,B905	zip-without-explicit-strict,B9	,B0	,B032	unintentional-type-annotation,B02	,B008	function-call-argument-default,B009	get-attr-with-constant,B024	abstract-base-class-without-abstract-method,B03	unintentional-type-annotation,B026	star-arg-unpacking-after-keyword-arg,B022	useless-contextlib-suppress,B019	cached-instance-method,B005	strip-with-multi-characters,B00	,B003	assignment-to-os-environ,B011	assert-false,B021	f-string-docstring,B90	,B010	set-attr-with-constant,B004	unreliable-callable-check,B017	assert-raises-exception,B012	jump-statement-in-finally,B016	cannot-raise-literal,B002	unary-prefix-increment,B006	mutable-argument-default,B015	useless-comparison,B029	except-with-empty-tuple,A00	,A0	,A001	builtin-variable-shadowing,A003	builtin-attribute-shadowing,A002	builtin-argument-shadowing,COM818	trailing-comma-on-bare-tuple-prohibited,COM8	,COM819	trailing-comma-prohibited,COM81	,COM812	trailing-comma-missing,C410	unnecessary-literal-within-list-call,C400	unnecessary-generator-list,C414	unnecessary-double-cast-or-process,C402	unnecessary-generator-dict,C404	unnecessary-list-comprehension-dict,C415	unnecessary-subscript-reversal,C417	unnecessary-map,C41	,C416	unnecessary-comprehension,C409	unnecessary-literal-within-tuple-call,C401	unnecessary-generator-set,C413	unnecessary-call-around-sorted,C40	,C403	unnecessary-list-comprehension-set,C405	unnecessary-literal-set,C408	unnecessary-collection-call,C411	unnecessary-list-call,C406	unnecessary-literal-dict,DTZ01	,DTZ002	call-datetime-today,DTZ007	call-datetime-strptime-without-zone,DTZ001	call-datetime-without-tzinfo,DTZ004	call-datetime-utcfromtimestamp,DTZ003	call-datetime-utcnow,DTZ0	,DTZ00	,DTZ006	call-datetime-fromtimestamp,DTZ005	call-datetime-now-without-tzinfo,DTZ011	call-date-today,DTZ012	call-date-fromtimestamp,T100	debugger,DJ008	model-without-dunder-str,DJ001	nullable-model-string-field,DJ0	,DJ003	locals-in-render-function,DJ007	all-with-model-form,DJ006	exclude-with-model-form,DJ013	non-leading-receiver-decorator,DJ00	,DJ01	non-leading-receiver-decorator,EM102	f-string-in-exception,EM101	raw-string-in-exception,EM1	,EM103	dot-format-in-exception,EM10	,EXE003	shebang-python,EXE0	,EXE00	,EXE002	shebang-missing-executable-file,EXE005	shebang-newline,EXE001	shebang-not-executable,EXE004	shebang-whitespace,ISC00	,ISC002	multi-line-implicit-string-concatenation,ISC001	single-line-implicit-string-concatenation,ISC003	explicit-string-concatenation,ISC0	,ICN00	unconventional-import-alias,ICN001	unconventional-import-alias,ICN0	unconventional-import-alias,G010	logging-warn,G101	logging-extra-attr-clash,G2	,G01	logging-warn,G1	logging-extra-attr-clash,G004	logging-f-string,G003	logging-string-concat,G10	logging-extra-attr-clash,G002	logging-percent-format,G0	,G00	,G201	logging-exc-info,G202	logging-redundant-exc-info,G001	logging-string-format,G20	,INP001	implicit-namespace-package,INP0	implicit-namespace-package,INP00	implicit-namespace-package,PIE807	prefer-list-builtin,PIE802	unnecessary-comprehension-any-all,PIE80	,PIE796	prefer-unique-enums,PIE810	single-starts-ends-with,PIE79	,PIE7	,PIE800	unnecessary-spread,PIE790	unnecessary-pass,PIE794	dupe-class-field-definitions,PIE8	,PIE81	single-starts-ends-with,PIE804	unnecessary-dict-kwargs,T203	p-print-found,T201	print-found,PYI03	type-comment-in-stub,PYI007	unrecognized-platform-check,PYI021	docstring-in-stub,PYI02	docstring-in-stub,PYI001	prefix-type-params,PYI006	bad-version-info-comparison,PYI010	non-empty-stub-body,PYI014	argument-simple-defaults,PYI0	,PYI009	pass-statement-stub-body,PYI008	unrecognized-platform-name,PYI033	type-comment-in-stub,PYI00	,PYI011	typed-argument-simple-defaults,PYI01	,PT007	parametrize-values-wrong-type,PT017	assert-in-except,PT023	incorrect-mark-parentheses-style,PT02	,PT005	incorrect-fixture-name-underscore,PT010	raises-without-exception,PT020	deprecated-yield-fixture,PT021	fixture-finalizer-callback,PT024	unnecessary-asyncio-mark-on-fixture,PT00	,PT012	raises-with-multiple-statements,PT003	extraneous-scope-function,PT01	,PT026	use-fixtures-without-parameters,PT008	patch-with-lambda,PT001	incorrect-fixture-parentheses-style,PT018	composite-assertion,PT006	parametrize-names-wrong-type,PT015	assert-always-false,PT022	useless-yield-fixture,PT002	fixture-positional-args,PT004	missing-fixture-name-underscore,PT009	unittest-assertion,PT013	incorrect-pytest-import,PT016	fail-without-message,PT019	fixture-param-without-value,PT025	erroneous-use-fixtures-on-fixture,PT0	,PT011	raises-too-broad,Q003	avoidable-escaped-quote,Q000	bad-quotes-inline-string,Q002	bad-quotes-docstring,Q0	,Q00	,Q001	bad-quotes-multiline-string,RSE102	unnecessary-paren-on-raise-exception,RSE1	unnecessary-paren-on-raise-exception,RSE10	unnecessary-paren-on-raise-exception,RET50	,RET504	unnecessary-assign,RET508	superfluous-else-break,RET501	unnecessary-return-none,RET502	implicit-return-value,RET503	implicit-return,RET505	superfluous-else-return,RET507	superfluous-else-continue,RET5	,RET506	superfluous-else-raise,SLF00	private-member-access,SLF0	private-member-access,SLF001	private-member-access,SIM2	,SIM112	use-capital-environment-variables,SIM201	negate-equal-op,SIM103	needless-bool,SIM110	reimplemented-builtin,SIM115	open-file-with-context-handler,SIM223	expr-and-false,SIM222	expr-or-true,SIM109	compare-with-tuple,SIM3	yoda-conditions,SIM401	dict-get-with-default,SIM102	collapsible-if,SIM1	,SIM108	use-ternary-operator,SIM210	if-expr-with-true-false,SIM20	,SIM105	use-contextlib-suppress,SIM107	return-in-try-except-finally,SIM4	dict-get-with-default,SIM118	key-in-dict,SIM116	manual-dict-lookup,SIM211	if-expr-with-false-true,SIM10	,SIM40	dict-get-with-default,SIM221	expr-or-not-expr,SIM30	yoda-conditions,SIM114	if-with-same-arms,SIM22	,SIM117	multiple-with-statements,SIM208	double-negation,SIM300	yoda-conditions,SIM202	negate-not-equal-op,SIM21	,SIM101	duplicate-isinstance-call,SIM220	expr-and-not-expr,SIM212	if-expr-with-twisted-arms,SIM11	,TID251	banned-api,TID252	relative-imports,TID2	,TID25	,TCH003	typing-only-standard-library-import,TCH004	runtime-import-in-type-checking-block,TCH002	typing-only-third-party-import,TCH001	typing-only-first-party-import,TCH005	empty-type-checking-block,TCH0	,TCH00	,ARG003	unused-class-method-argument,ARG0	,ARG00	,ARG002	unused-method-argument,ARG005	unused-lambda-argument,ARG004	unused-static-method-argument,ARG001	unused-function-argument,PTH116	pathlib-stat,PTH122	pathlib-splitext,PTH104	pathlib-rename,PTH110	pathlib-exists,PTH121	pathlib-samefile,PTH108	pathlib-unlink,PTH123	pathlib-open,PTH107	pathlib-remove,PTH119	pathlib-basename,PTH10	,PTH118	pathlib-join,PTH101	pathlib-chmod,PTH114	pathlib-is-link,PTH100	pathlib-abspath,PTH11	,PTH102	pathlib-mkdir,PTH120	pathlib-dirname,PTH124	pathlib-py-path,PTH1	,PTH111	pathlib-expanduser,PTH105	pathlib-replace,PTH113	pathlib-is-file,PTH117	pathlib-is-abs,PTH115	pathlib-readlink,PTH103	pathlib-makedirs,PTH109	pathlib-getcwd,PTH106	pathlib-rmdir,PTH12	,PTH112	pathlib-is-dir,I00	,I0	,I002	missing-required-import,I001	unsorted-imports,C901	complex-structure,NPY0	,NPY00	,NPY001	numpy-deprecated-type-alias,NPY002	numpy-legacy-random,N805	invalid-first-argument-name-for-method,N81	,N804	invalid-first-argument-name-for-class-method,N999	invalid-module-name,N802	invalid-function-name,N807	dunder-function-name,N815	mixed-case-variable-in-class-scope,N818	error-suffix-on-exception-name,N80	,N816	mixed-case-variable-in-global-scope,N806	non-lowercase-variable-in-function,N811	constant-imported-as-non-constant,N813	camelcase-imported-as-lowercase,N803	invalid-argument-name,N8	,N99	invalid-module-name,N812	lowercase-imported-as-non-lowercase,N9	invalid-module-name,N801	invalid-class-name,N817	camelcase-imported-as-acronym,N814	camelcase-imported-as-constant,PD9	df-is-a-bad-variable-name,PD015	use-of-pd-merge,PD002	use-of-inplace-argument,PD013	use-of-dot-stack,PD01	,PD0	,PD00	,PD901	df-is-a-bad-variable-name,PD003	use-of-dot-is-null,PD012	use-of-dot-read-table,PD008	use-of-dot-at,PD009	use-of-dot-iat,PD010	use-of-dot-pivot-or-unstack,PD007	use-of-dot-ix,PD004	use-of-dot-not-null,PD011	use-of-dot-values,PD90	df-is-a-bad-variable-name,W292	no-new-line-at-end-of-file,E7	,E73	lambda-assignment,W5	doc-line-too-long,W6	invalid-escape-sequence,W60	invalid-escape-sequence,E40	,E402	module-import-not-at-top-of-file,E71	,W29	,E702	multiple-statements-on-one-line-semicolon,E501	line-too-long,E99	syntax-error,E713	not-in-test,E10	mixed-spaces-and-tabs,E50	line-too-long,E70	,E72	,W293	blank-line-contains-whitespace,E742	ambiguous-class-name,W291	trailing-whitespace,E9	,W19	indentation-contains-tabs,E711	none-comparison,W2	,E731	lambda-assignment,E401	multiple-imports-on-one-line,E721	type-comparison,E74	,W1	indentation-contains-tabs,E1	mixed-spaces-and-tabs,W605	invalid-escape-sequence,E703	useless-semicolon,E714	not-is-test,E902	io-error,W505	doc-line-too-long,E4	,E90	io-error,E	,E712	true-false-comparison,W191	indentation-contains-tabs,E701	multiple-statements-on-one-line-colon,E5	line-too-long,E743	ambiguous-function-name,W	,W50	doc-line-too-long,E722	bare-except,E999	syntax-error,E741	ambiguous-variable-name,E101	mixed-spaces-and-tabs,D300	triple-single-quotes,D103	public-function,D405	capitalize-section-name,D4	,D40	,D205	blank-line-after-summary,D213	multi-line-summary-second-line,D409	section-underline-matches-section-length,D417	undocumented-param,D200	fits-on-one-line,D401	non-imperative-mood,D402	no-signature,D410	blank-line-after-section,D105	magic-method,D202	no-blank-line-after-function,D209	new-line-after-last-paragraph,D107	public-init,D214	section-not-over-indented,D407	dashed-underline-after-section,D414	empty-docstring-section,D416	section-name-ends-in-colon,D418	overload-with-docstring,D10	,D211	no-blank-line-before-class,D400	ends-in-period,D408	section-underline-after-name,D20	,D104	public-package,D301	escape-sequence-in-docstring,D203	one-blank-line-before-class,D208	no-over-indentation,D419	empty-docstring,D207	no-under-indentation,D100	public-module,D21	,D101	public-class,D212	multi-line-summary-first-line,D210	no-surrounding-whitespace,D204	one-blank-line-after-class,D3	,D30	,D102	public-method,D106	public-nested-class,D41	,D403	first-line-capitalized,D406	new-line-after-section-name,D415	ends-in-punctuation,D413	blank-line-after-last-section,D404	docstring-starts-with-this,D412	no-blank-lines-between-header-and-content,D411	blank-line-before-section,D1	,D2	,D201	no-blank-line-before-function,D206	indent-with-spaces,D215	section-underline-not-over-indented,F622	two-starred-expressions,F602	multi-value-repeated-key-variable,F84	,F404	late-future-import,F503	percent-format-expected-sequence,F60	,F81	redefined-while-unused,F407	future-feature-not-defined,F842	unused-annotation,F40	,F508	percent-format-star-requires-sequence,F901	raise-not-implemented,F54	f-string-missing-placeholders,F525	string-dot-format-mixing-automatic,F707	default-except-not-last,F521	string-dot-format-invalid-format,F6	,F50	,F70	,F9	raise-not-implemented,F841	unused-variable,F632	is-literal,F401	unused-import,F403	import-star,F811	redefined-while-unused,F541	f-string-missing-placeholders,F702	continue-outside-loop,F505	percent-format-missing-argument,F72	forward-annotation-syntax-error,F504	percent-format-extra-named-arguments,F4	,F523	string-dot-format-extra-positional-arguments,F621	expressions-in-star-assignment,F52	,F701	break-outside-loop,F631	assert-tuple,F821	undefined-name,F8	,F509	percent-format-unsupported-format-character,F405	import-star-usage,F507	percent-format-positional-count-mismatch,F506	percent-format-mixed-positional-and-named,F722	forward-annotation-syntax-error,F62	,F82	,F634	if-tuple,F7	,F706	return-outside-function,F502	percent-format-expected-mapping,F601	multi-value-repeated-key-literal,F63	,F406	import-star-not-permitted,F402	import-shadowed-by-loop-var,F501	percent-format-invalid-format,F524	string-dot-format-missing-arguments,F90	raise-not-implemented,F522	string-dot-format-extra-named-arguments,F823	undefined-local,F633	invalid-print-syntax,F822	undefined-export,F704	yield-outside-function,F5	,PGH003	blanket-type-ignore,PGH002	deprecated-log-warn,PGH004	blanket-noqa,PGH001	no-eval,PGH0	,PGH00	,PLR02	property-with-parameters,PLR2	magic-value-comparison,PLW012	useless-else-on-loop,PLR	,PLR091	,PLW0120	useless-else-on-loop,PLW0603	global-statement,PLE1142	await-outside-async,PLR0206	property-with-parameters,PLE	,PLE1307	bad-string-format-type,PLR1722	consider-using-sys-exit,PLR5501	collapsible-else-if,PLR04	consider-using-from-import,PLC30	unnecessary-direct-lambda-call,PLE130	bad-string-format-type,PLR5	collapsible-else-if,PLW29	redefined-loop-name,PLE1205	logging-too-many-args,PLR20	magic-value-comparison,PLC300	unnecessary-direct-lambda-call,PLE11	await-outside-async,PLW01	useless-else-on-loop,PLE0100	yield-in-init,PLC3	unnecessary-direct-lambda-call,PLW290	redefined-loop-name,PLC0	useless-import-alias,PLE0117	nonlocal-without-binding,PLC0414	useless-import-alias,PLR0912	too-many-branches,PLR1701	consider-merging-isinstance,PLE25	bidirectional-unicode,PLR09	,PLR0402	consider-using-from-import,PLC041	useless-import-alias,PLE250	bidirectional-unicode,PLE0101	return-in-init,PLE1310	bad-str-strip-call,PLR0911	too-many-return-statements,PLR0915	too-many-statements,PLR17	,PLE011	,PLE13	,PLE1206	logging-too-few-args,PLE0604	invalid-all-object,PLE01	,PLE131	bad-str-strip-call,PLE010	,PLR2004	magic-value-comparison,PLR170	consider-merging-isinstance,PLR172	consider-using-sys-exit,PLW	,PLW060	,PLE120	,PLE0	,PLC04	useless-import-alias,PLE2502	bidirectional-unicode,PLR0913	too-many-arguments,PLR020	property-with-parameters,PLE2	bidirectional-unicode,PLR0133	comparison-of-constant,PLR040	consider-using-from-import,PLR55	collapsible-else-if,PLE1	,PLR550	collapsible-else-if,PLW2	redefined-loop-name,PLR200	magic-value-comparison,PLE12	,PLW06	,PLE060	,PLC3002	unnecessary-direct-lambda-call,PLW2901	redefined-loop-name,PLR0	,PLE0605	invalid-all-format,PLE114	await-outside-async,PLC	,PLW0	,PLW0602	global-variable-not-assigned,PLE0118	used-prior-global-declaration,PLE06	,PLR1	,PLR01	comparison-of-constant,PLR013	comparison-of-constant,UP021	replace-universal-newlines,UP010	unnecessary-future-import,UP011	lru-cache-without-parameters,UP01	,UP03	,UP025	rewrite-unicode-literal,UP035	import-replacements,UP026	rewrite-mock-import,UP030	format-literals,UP001	useless-metaclass-type,UP0	,UP007	typing-union,UP003	type-of-primitive,UP017	datetime-timezone-utc,UP022	replace-stdout-stderr,UP037	quoted-annotation,UP009	utf8-encoding-declaration,UP038	isinstance-with-tuple,UP006	deprecated-collection-type,UP008	super-call-with-parameters,UP023	rewrite-c-element-tree,UP013	convert-typed-dict-functional-to-class,UP032	f-string,UP004	useless-object-inheritance,UP018	native-literals,UP031	printf-string-formatting,UP00	,UP005	deprecated-unittest-alias,UP020	open-alias,UP029	unnecessary-builtin-import,UP02	,UP014	convert-named-tuple-functional-to-class,UP012	unnecessary-encode-utf8,UP015	redundant-open-modes,UP019	typing-text-str-alias,UP024	os-error-alias,UP028	rewrite-yield-from,UP033	functools-cache,UP034	extraneous-parentheses,UP036	outdated-version-block,UP027	rewrite-list-comprehension,RUF006	asyncio-dangling-task,RUF00	,RUF1	unused-noqa,RUF001	ambiguous-unicode-character-string,RUF100	unused-noqa,RUF005	unpack-instead-of-concatenating-to-collection-literal,RUF002	ambiguous-unicode-character-docstring,RUF10	unused-noqa,RUF0	,RUF003	ambiguous-unicode-character-comment,TRY20	,TRY200	reraise-no-cause,TRY300	try-consider-else,TRY201	verbose-raise,TRY401	verbose-log-message,TRY40	,TRY004	prefer-type-error,TRY002	raise-vanilla-class,TRY30	,TRY00	,TRY0	,TRY4	,TRY2	,TRY301	raise-within-try,TRY003	raise-vanilla-args,TRY400	error-instead-of-exception,TRY3	}"
complete -c ruff -n "__fish_seen_subcommand_from check" -l per-file-ignores -d 'List of mappings from file pattern to code to exclude' -r
complete -c ruff -n "__fish_seen_subcommand_from check" -l exclude -d 'List of paths, used to omit files and/or directories from analysis' -r
complete -c ruff -n "__fish_seen_subcommand_from check" -l extend-exclude -d 'Like --exclude, but adds additional files and directories on top of those already excluded' -r
complete -c ruff -n "__fish_seen_subcommand_from check" -l fixable -d 'List of rule codes to treat as eligible for autofix. Only applicable when autofix itself is enabled (e.g., via `--fix`)' -r -f -a "{ALL	all rules,F	Pyflakes,C90	mccabe,I	isort,N	pep8-naming,D	pydocstyle,UP	pyupgrade,YTT	flake8-2020,ANN	flake8-annotations,S	flake8-bandit,BLE	flake8-blind-except,FBT	flake8-boolean-trap,B	flake8-bugbear,A	flake8-builtins,COM	flake8-commas,C4	flake8-comprehensions,DTZ	flake8-datetimez,T10	flake8-debugger,DJ	flake8-django,EM	flake8-errmsg,EXE	flake8-executable,ISC	flake8-implicit-str-concat,ICN	flake8-import-conventions,G	flake8-logging-format,INP	flake8-no-pep420,PIE	flake8-pie,T20	flake8-print,PYI	flake8-pyi,PT	flake8-pytest-style,Q	flake8-quotes,RSE	flake8-raise,RET	flake8-return,SLF	flake8-self,SIM	flake8-simplify,TID	flake8-tidy-imports,TCH	flake8-type-checking,ARG	flake8-unused-arguments,PTH	flake8-use-pathlib,ERA	eradicate,PD	pandas-vet,PGH	pygrep-hooks,PL	Pylint,TRY	tryceratops,NPY	NumPy-specific rules,RUF	Ruff-specific rules,ERA0	commented-out-code,ERA00	commented-out-code,ERA001	commented-out-code,YTT10	,YTT3	,YTT103	sys-version-cmp-str3,YTT203	sys-version-info1-cmp-int,YTT301	sys-version0-referenced,YTT2	,YTT20	,YTT201	sys-version-info0-eq3-referenced,YTT204	sys-version-info-minor-cmp-int,YTT303	sys-version-slice1-referenced,YTT30	,YTT202	six-py3-referenced,YTT102	sys-version2-referenced,YTT101	sys-version-slice3-referenced,YTT302	sys-version-cmp-str10,YTT1	,ANN4	any-type,ANN101	missing-type-self,ANN00	,ANN1	,ANN002	missing-type-args,ANN201	missing-return-type-public-function,ANN205	missing-return-type-static-method,ANN401	any-type,ANN206	missing-return-type-class-method,ANN40	any-type,ANN10	,ANN001	missing-type-function-argument,ANN20	,ANN003	missing-type-kwargs,ANN0	,ANN202	missing-return-type-private-function,ANN204	missing-return-type-special-method,ANN2	,ANN102	missing-type-cls,S102	exec-builtin,S103	bad-file-permissions,S50	,S3	hashlib-insecure-hash-function,S501	request-with-no-cert-validation,S1	,S60	hardcoded-sql-expression,S105	hardcoded-password-string,S506	unsafe-yaml-load,S324	hashlib-insecure-hash-function,S5	,S104	hardcoded-bind-all-interfaces,S106	hardcoded-password-func-arg,S112	try-except-continue,S101	assert,S509	snmp-weak-cryptography,S11	,S32	hashlib-insecure-hash-function,S61	logging-config-insecure-listen,S107	hardcoded-password-default,S7	jinja2-autoescape-false,S113	request-without-timeout,S612	logging-config-insecure-listen,S110	try-except-pass,S608	hardcoded-sql-expression,S70	jinja2-autoescape-false,S701	jinja2-autoescape-false,S508	snmp-insecure-version,S10	,S108	hardcoded-temp-file,S6	,BLE001	blind-except,BLE0	blind-except,BLE00	blind-except,FBT0	,FBT001	boolean-positional-arg-in-function-definition,FBT00	,FBT003	boolean-positional-value-in-function-call,FBT002	boolean-default-value-in-function-definition,B023	function-uses-loop-variable,B014	duplicate-handler-exception,B025	duplicate-try-block-exception,B01	,B020	loop-variable-overrides-iterator,B007	unused-loop-control-variable,B027	empty-method-without-abstract-decorator,B904	raise-without-from-inside-except,B013	redundant-tuple-in-exception-handler,B018	useless-expression,B905	zip-without-explicit-strict,B9	,B0	,B032	unintentional-type-annotation,B02	,B008	function-call-argument-default,B009	get-attr-with-constant,B024	abstract-base-class-without-abstract-method,B03	unintentional-type-annotation,B026	star-arg-unpacking-after-keyword-arg,B022	useless-contextlib-suppress,B019	cached-instance-method,B005	strip-with-multi-characters,B00	,B003	assignment-to-os-environ,B011	assert-false,B021	f-string-docstring,B90	,B010	set-attr-with-constant,B004	unreliable-callable-check,B017	assert-raises-exception,B012	jump-statement-in-finally,B016	cannot-raise-literal,B002	unary-prefix-increment,B006	mutable-argument-default,B015	useless-comparison,B029	except-with-empty-tuple,A00	,A0	,A001	builtin-variable-shadowing,A003	builtin-attribute-shadowing,A002	builtin-argument-shadowing,COM818	trailing-comma-on-bare-tuple-prohibited,COM8	,COM819	trailing-comma-prohibited,COM81	,COM812	trailing-comma-missing,C410	unnecessary-literal-within-list-call,C400	unnecessary-generator-list,C414	unnecessary-double-cast-or-process,C402	unnecessary-generator-dict,C404	unnecessary-list-comprehension-dict,C415	unnecessary-subscript-reversal,C417	unnecessary-map,C41	,C416	unnecessary-comprehension,C409	unnecessary-literal-within-tuple-call,C401	unnecessary-generator-set,C413	unnecessary-call-around-sorted,C40	,C403	unnecessary-list-comprehension-set,C405	unnecessary-literal-set,C408	unnecessary-collection-call,C411	unnecessary-list-call,C406	unnecessary-literal-dict,DTZ01	,DTZ002	call-datetime-today,DTZ007	call-datetime-strptime-without-zone,DTZ001	call-datetime-without-tzinfo,DTZ004	call-datetime-utcfromtimestamp,DTZ003	call-datetime-utcnow,DTZ0	,DTZ00	,DTZ006	call-datetime-fromtimestamp,DTZ005	call-datetime-now-without-tzinfo,DTZ011	call-date-today,DTZ012	call-date-fromtimestamp,T100	debugger,DJ008	model-without-dunder-str,DJ001	nullable-model-string-field,DJ0	,DJ003	locals-in-render-function,DJ007	all-with-model-form,DJ006	exclude-with-model-form,DJ013	non-leading-receiver-decorator,DJ00	,DJ01	non-leading-receiver-decorator,EM102	f-string-in-exception,EM101	raw-string-in-exception,EM1	,EM103	dot-format-in-exception,EM10	,EXE003	shebang-python,EXE0	,EXE00	,EXE002	shebang-missing-executable-file,EXE005	shebang-newline,EXE001	shebang-not-executable,EXE004	shebang-whitespace,ISC00	,ISC002	multi-line-implicit-string-concatenation,ISC001	single-line-implicit-string-concatenation,ISC003	explicit-string-concatenation,ISC0	,ICN00	unconventional-import-alias,ICN001	unconventional-import-alias,ICN0	unconventional-import-alias,G010	logging-warn,G101	logging-extra-attr-clash,G2	,G01	logging-warn,G1	logging-extra-attr-clash,G004	logging-f-string,G003	logging-string-concat,G10	logging-extra-attr-clash,G002	logging-percent-format,G0	,G00	,G201	logging-exc-info,G202	logging-redundant-exc-info,G001	logging-string-format,G20	,INP001	implicit-namespace-package,INP0	implicit-namespace-package,INP00	implicit-namespace-package,PIE807	prefer-list-builtin,PIE802	unnecessary-comprehension-any-all,PIE80	,PIE796	prefer-unique-enums,PIE810	single-starts-ends-with,PIE79	,PIE7	,PIE800	unnecessary-spread,PIE790	unnecessary-pass,PIE794	dupe-class-field-definitions,PIE8	,PIE81	single-starts-ends-with,PIE804	unnecessary-dict-kwargs,T203	p-print-found,T201	print-found,PYI03	type-comment-in-stub,PYI007	unrecognized-platform-check,PYI021	docstring-in-stub,PYI02	docstring-in-stub,PYI001	prefix-type-params,PYI006	bad-version-info-comparison,PYI010	non-empty-stub-body,PYI014	argument-simple-defaults,PYI0	,PYI009	pass-statement-stub-body,PYI008	unrecognized-platform-name,PYI033	type-comment-in-stub,PYI00	,PYI011	typed-argument-simple-defaults,PYI01	,PT007	parametrize-values-wrong-type,PT017	assert-in-except,PT023	incorrect-mark-parentheses-style,PT02	,PT005	incorrect-fixture-name-underscore,PT010	raises-without-exception,PT020	deprecated-yield-fixture,PT021	fixture-finalizer-callback,PT024	unnecessary-asyncio-mark-on-fixture,PT00	,PT012	raises-with-multiple-statements,PT003	extraneous-scope-function,PT01	,PT026	use-fixtures-without-parameters,PT008	patch-with-lambda,PT001	incorrect-fixture-parentheses-style,PT018	composite-assertion,PT006	parametrize-names-wrong-type,PT015	assert-always-false,PT022	useless-yield-fixture,PT002	fixture-positional-args,PT004	missing-fixture-name-underscore,PT009	unittest-assertion,PT013	incorrect-pytest-import,PT016	fail-without-message,PT019	fixture-param-without-value,PT025	erroneous-use-fixtures-on-fixture,PT0	,PT011	raises-too-broad,Q003	avoidable-escaped-quote,Q000	bad-quotes-inline-string,Q002	bad-quotes-docstring,Q0	,Q00	,Q001	bad-quotes-multiline-string,RSE102	unnecessary-paren-on-raise-exception,RSE1	unnecessary-paren-on-raise-exception,RSE10	unnecessary-paren-on-raise-exception,RET50	,RET504	unnecessary-assign,RET508	superfluous-else-break,RET501	unnecessary-return-none,RET502	implicit-return-value,RET503	implicit-return,RET505	superfluous-else-return,RET507	superfluous-else-continue,RET5	,RET506	superfluous-else-raise,SLF00	private-member-access,SLF0	private-member-access,SLF001	private-member-access,SIM2	,SIM112	use-capital-environment-variables,SIM201	negate-equal-op,SIM103	needless-bool,SIM110	reimplemented-builtin,SIM115	open-file-with-context-handler,SIM223	expr-and-false,SIM222	expr-or-true,SIM109	compare-with-tuple,SIM3	yoda-conditions,SIM401	dict-get-with-default,SIM102	collapsible-if,SIM1	,SIM108	use-ternary-operator,SIM210	if-expr-with-true-false,SIM20	,SIM105	use-contextlib-suppress,SIM107	return-in-try-except-finally,SIM4	dict-get-with-default,SIM118	key-in-dict,SIM116	manual-dict-lookup,SIM211	if-expr-with-false-true,SIM10	,SIM40	dict-get-with-default,SIM221	expr-or-not-expr,SIM30	yoda-conditions,SIM114	if-with-same-arms,SIM22	,SIM117	multiple-with-statements,SIM208	double-negation,SIM300	yoda-conditions,SIM202	negate-not-equal-op,SIM21	,SIM101	duplicate-isinstance-call,SIM220	expr-and-not-expr,SIM212	if-expr-with-twisted-arms,SIM11	,TID251	banned-api,TID252	relative-imports,TID2	,TID25	,TCH003	typing-only-standard-library-import,TCH004	runtime-import-in-type-checking-block,TCH002	typing-only-third-party-import,TCH001	typing-only-first-party-import,TCH005	empty-type-checking-block,TCH0	,TCH00	,ARG003	unused-class-method-argument,ARG0	,ARG00	,ARG002	unused-method-argument,ARG005	unused-lambda-argument,ARG004	unused-static-method-argument,ARG001	unused-function-argument,PTH116	pathlib-stat,PTH122	pathlib-splitext,PTH104	pathlib-rename,PTH110	pathlib-exists,PTH121	pathlib-samefile,PTH108	pathlib-unlink,PTH123	pathlib-open,PTH107	pathlib-remove,PTH119	pathlib-basename,PTH10	,PTH118	pathlib-join,PTH101	pathlib-chmod,PTH114	pathlib-is-link,PTH100	pathlib-abspath,PTH11	,PTH102	pathlib-mkdir,PTH120	pathlib-dirname,PTH124	pathlib-py-path,PTH1	,PTH111	pathlib-expanduser,PTH105	pathlib-replace,PTH113	pathlib-is-file,PTH117	pathlib-is-abs,PTH115	pathlib-readlink,PTH103	pathlib-makedirs,PTH109	pathlib-getcwd,PTH106	pathlib-rmdir,PTH12	,PTH112	pathlib-is-dir,I00	,I0	,I002	missing-required-import,I001	unsorted-imports,C901	complex-structure,NPY0	,NPY00	,NPY001	numpy-deprecated-type-alias,NPY002	numpy-legacy-random,N805	invalid-first-argument-name-for-method,N81	,N804	invalid-first-argument-name-for-class-method,N999	invalid-module-name,N802	invalid-function-name,N807	dunder-function-name,N815	mixed-case-variable-in-class-scope,N818	error-suffix-on-exception-name,N80	,N816	mixed-case-variable-in-global-scope,N806	non-lowercase-variable-in-function,N811	constant-imported-as-non-constant,N813	camelcase-imported-as-lowercase,N803	invalid-argument-name,N8	,N99	invalid-module-name,N812	lowercase-imported-as-non-lowercase,N9	invalid-module-name,N801	invalid-class-name,N817	camelcase-imported-as-acronym,N814	camelcase-imported-as-constant,PD9	df-is-a-bad-variable-name,PD015	use-of-pd-merge,PD002	use-of-inplace-argument,PD013	use-of-dot-stack,PD01	,PD0	,PD00	,PD901	df-is-a-bad-variable-name,PD003	use-of-dot-is-null,PD012	use-of-dot-read-table,PD008	use-of-dot-at,PD009	use-of-dot-iat,PD010	use-of-dot-pivot-or-unstack,PD007	use-of-dot-ix,PD004	use-of-dot-not-null,PD011	use-of-dot-values,PD90	df-is-a-bad-variable-name,W292	no-new-line-at-end-of-file,E7	,E73	lambda-assignment,W5	doc-line-too-long,W6	invalid-escape-sequence,W60	invalid-escape-sequence,E40	,E402	module-import-not-at-top-of-file,E71	,W29	,E702	multiple-statements-on-one-line-semicolon,E501	line-too-long,E99	syntax-error,E713	not-in-test,E10	mixed-spaces-and-tabs,E50	line-too-long,E70	,E72	,W293	blank-line-contains-whitespace,E742	ambiguous-class-name,W291	trailing-whitespace,E9	,W19	indentation-contains-tabs,E711	none-comparison,W2	,E731	lambda-assignment,E401	multiple-imports-on-one-line,E721	type-comparison,E74	,W1	indentation-contains-tabs,E1	mixed-spaces-and-tabs,W605	invalid-escape-sequence,E703	useless-semicolon,E714	not-is-test,E902	io-error,W505	doc-line-too-long,E4	,E90	io-error,E	,E712	true-false-comparison,W191	indentation-contains-tabs,E701	multiple-statements-on-one-line-colon,E5	line-too-long,E743	ambiguous-function-name,W	,W50	doc-line-too-long,E722	bare-except,E999	syntax-error,E741	ambiguous-variable-name,E101	mixed-spaces-and-tabs,D300	triple-single-quotes,D103	public-function,D405	capitalize-section-name,D4	,D40	,D205	blank-line-after-summary,D213	multi-line-summary-second-line,D409	section-underline-matches-section-length,D417	undocumented-param,D200	fits-on-one-line,D401	non-imperative-mood,D402	no-signature,D410	blank-line-after-section,D105	magic-method,D202	no-blank-line-after-function,D209	new-line-after-last-paragraph,D107	public-init,D214	section-not-over-indented,D407	dashed-underline-after-section,D414	empty-docstring-section,D416	section-name-ends-in-colon,D418	overload-with-docstring,D10	,D211	no-blank-line-before-class,D400	ends-in-period,D408	section-underline-after-name,D20	,D104	public-package,D301	escape-sequence-in-docstring,D203	one-blank-line-before-class,D208	no-over-indentation,D419	empty-docstring,D207	no-under-indentation,D100	public-module,D21	,D101	public-class,D212	multi-line-summary-first-line,D210	no-surrounding-whitespace,D204	one-blank-line-after-class,D3	,D30	,D102	public-method,D106	public-nested-class,D41	,D403	first-line-capitalized,D406	new-line-after-section-name,D415	ends-in-punctuation,D413	blank-line-after-last-section,D404	docstring-starts-with-this,D412	no-blank-lines-between-header-and-content,D411	blank-line-before-section,D1	,D2	,D201	no-blank-line-before-function,D206	indent-with-spaces,D215	section-underline-not-over-indented,F622	two-starred-expressions,F602	multi-value-repeated-key-variable,F84	,F404	late-future-import,F503	percent-format-expected-sequence,F60	,F81	redefined-while-unused,F407	future-feature-not-defined,F842	unused-annotation,F40	,F508	percent-format-star-requires-sequence,F901	raise-not-implemented,F54	f-string-missing-placeholders,F525	string-dot-format-mixing-automatic,F707	default-except-not-last,F521	string-dot-format-invalid-format,F6	,F50	,F70	,F9	raise-not-implemented,F841	unused-variable,F632	is-literal,F401	unused-import,F403	import-star,F811	redefined-while-unused,F541	f-string-missing-placeholders,F702	continue-outside-loop,F505	percent-format-missing-argument,F72	forward-annotation-syntax-error,F504	percent-format-extra-named-arguments,F4	,F523	string-dot-format-extra-positional-arguments,F621	expressions-in-star-assignment,F52	,F701	break-outside-loop,F631	assert-tuple,F821	undefined-name,F8	,F509	percent-format-unsupported-format-character,F405	import-star-usage,F507	percent-format-positional-count-mismatch,F506	percent-format-mixed-positional-and-named,F722	forward-annotation-syntax-error,F62	,F82	,F634	if-tuple,F7	,F706	return-outside-function,F502	percent-format-expected-mapping,F601	multi-value-repeated-key-literal,F63	,F406	import-star-not-permitted,F402	import-shadowed-by-loop-var,F501	percent-format-invalid-format,F524	string-dot-format-missing-arguments,F90	raise-not-implemented,F522	string-dot-format-extra-named-arguments,F823	undefined-local,F633	invalid-print-syntax,F822	undefined-export,F704	yield-outside-function,F5	,PGH003	blanket-type-ignore,PGH002	deprecated-log-warn,PGH004	blanket-noqa,PGH001	no-eval,PGH0	,PGH00	,PLR02	property-with-parameters,PLR2	magic-value-comparison,PLW012	useless-else-on-loop,PLR	,PLR091	,PLW0120	useless-else-on-loop,PLW0603	global-statement,PLE1142	await-outside-async,PLR0206	property-with-parameters,PLE	,PLE1307	bad-string-format-type,PLR1722	consider-using-sys-exit,PLR5501	collapsible-else-if,PLR04	consider-using-from-import,PLC30	unnecessary-direct-lambda-call,PLE130	bad-string-format-type,PLR5	collapsible-else-if,PLW29	redefined-loop-name,PLE1205	logging-too-many-args,PLR20	magic-value-comparison,PLC300	unnecessary-direct-lambda-call,PLE11	await-outside-async,PLW01	useless-else-on-loop,PLE0100	yield-in-init,PLC3	unnecessary-direct-lambda-call,PLW290	redefined-loop-name,PLC0	useless-import-alias,PLE0117	nonlocal-without-binding,PLC0414	useless-import-alias,PLR0912	too-many-branches,PLR1701	consider-merging-isinstance,PLE25	bidirectional-unicode,PLR09	,PLR0402	consider-using-from-import,PLC041	useless-import-alias,PLE250	bidirectional-unicode,PLE0101	return-in-init,PLE1310	bad-str-strip-call,PLR0911	too-many-return-statements,PLR0915	too-many-statements,PLR17	,PLE011	,PLE13	,PLE1206	logging-too-few-args,PLE0604	invalid-all-object,PLE01	,PLE131	bad-str-strip-call,PLE010	,PLR2004	magic-value-comparison,PLR170	consider-merging-isinstance,PLR172	consider-using-sys-exit,PLW	,PLW060	,PLE120	,PLE0	,PLC04	useless-import-alias,PLE2502	bidirectional-unicode,PLR0913	too-many-arguments,PLR020	property-with-parameters,PLE2	bidirectional-unicode,PLR0133	comparison-of-constant,PLR040	consider-using-from-import,PLR55	collapsible-else-if,PLE1	,PLR550	collapsible-else-if,PLW2	redefined-loop-name,PLR200	magic-value-comparison,PLE12	,PLW06	,PLE060	,PLC3002	unnecessary-direct-lambda-call,PLW2901	redefined-loop-name,PLR0	,PLE0605	invalid-all-format,PLE114	await-outside-async,PLC	,PLW0	,PLW0602	global-variable-not-assigned,PLE0118	used-prior-global-declaration,PLE06	,PLR1	,PLR01	comparison-of-constant,PLR013	comparison-of-constant,UP021	replace-universal-newlines,UP010	unnecessary-future-import,UP011	lru-cache-without-parameters,UP01	,UP03	,UP025	rewrite-unicode-literal,UP035	import-replacements,UP026	rewrite-mock-import,UP030	format-literals,UP001	useless-metaclass-type,UP0	,UP007	typing-union,UP003	type-of-primitive,UP017	datetime-timezone-utc,UP022	replace-stdout-stderr,UP037	quoted-annotation,UP009	utf8-encoding-declaration,UP038	isinstance-with-tuple,UP006	deprecated-collection-type,UP008	super-call-with-parameters,UP023	rewrite-c-element-tree,UP013	convert-typed-dict-functional-to-class,UP032	f-string,UP004	useless-object-inheritance,UP018	native-literals,UP031	printf-string-formatting,UP00	,UP005	deprecated-unittest-alias,UP020	open-alias,UP029	unnecessary-builtin-import,UP02	,UP014	convert-named-tuple-functional-to-class,UP012	unnecessary-encode-utf8,UP015	redundant-open-modes,UP019	typing-text-str-alias,UP024	os-error-alias,UP028	rewrite-yield-from,UP033	functools-cache,UP034	extraneous-parentheses,UP036	outdated-version-block,UP027	rewrite-list-comprehension,RUF006	asyncio-dangling-task,RUF00	,RUF1	unused-noqa,RUF001	ambiguous-unicode-character-string,RUF100	unused-noqa,RUF005	unpack-instead-of-concatenating-to-collection-literal,RUF002	ambiguous-unicode-character-docstring,RUF10	unused-noqa,RUF0	,RUF003	ambiguous-unicode-character-comment,TRY20	,TRY200	reraise-no-cause,TRY300	try-consider-else,TRY201	verbose-raise,TRY401	verbose-log-message,TRY40	,TRY004	prefer-type-error,TRY002	raise-vanilla-class,TRY30	,TRY00	,TRY0	,TRY4	,TRY2	,TRY301	raise-within-try,TRY003	raise-vanilla-args,TRY400	error-instead-of-exception,TRY3	}"
complete -c ruff -n "__fish_seen_subcommand_from check" -l unfixable -d 'List of rule codes to treat as ineligible for autofix. Only applicable when autofix itself is enabled (e.g., via `--fix`)' -r -f -a "{ALL	all rules,F	Pyflakes,C90	mccabe,I	isort,N	pep8-naming,D	pydocstyle,UP	pyupgrade,YTT	flake8-2020,ANN	flake8-annotations,S	flake8-bandit,BLE	flake8-blind-except,FBT	flake8-boolean-trap,B	flake8-bugbear,A	flake8-builtins,COM	flake8-commas,C4	flake8-comprehensions,DTZ	flake8-datetimez,T10	flake8-debugger,DJ	flake8-django,EM	flake8-errmsg,EXE	flake8-executable,ISC	flake8-implicit-str-concat,ICN	flake8-import-conventions,G	flake8-logging-format,INP	flake8-no-pep420,PIE	flake8-pie,T20	flake8-print,PYI	flake8-pyi,PT	flake8-pytest-style,Q	flake8-quotes,RSE	flake8-raise,RET	flake8-return,SLF	flake8-self,SIM	flake8-simplify,TID	flake8-tidy-imports,TCH	flake8-type-checking,ARG	flake8-unused-arguments,PTH	flake8-use-pathlib,ERA	eradicate,PD	pandas-vet,PGH	pygrep-hooks,PL	Pylint,TRY	tryceratops,NPY	NumPy-specific rules,RUF	Ruff-specific rules,ERA0	commented-out-code,ERA00	commented-out-code,ERA001	commented-out-code,YTT10	,YTT3	,YTT103	sys-version-cmp-str3,YTT203	sys-version-info1-cmp-int,YTT301	sys-version0-referenced,YTT2	,YTT20	,YTT201	sys-version-info0-eq3-referenced,YTT204	sys-version-info-minor-cmp-int,YTT303	sys-version-slice1-referenced,YTT30	,YTT202	six-py3-referenced,YTT102	sys-version2-referenced,YTT101	sys-version-slice3-referenced,YTT302	sys-version-cmp-str10,YTT1	,ANN4	any-type,ANN101	missing-type-self,ANN00	,ANN1	,ANN002	missing-type-args,ANN201	missing-return-type-public-function,ANN205	missing-return-type-static-method,ANN401	any-type,ANN206	missing-return-type-class-method,ANN40	any-type,ANN10	,ANN001	missing-type-function-argument,ANN20	,ANN003	missing-type-kwargs,ANN0	,ANN202	missing-return-type-private-function,ANN204	missing-return-type-special-method,ANN2	,ANN102	missing-type-cls,S102	exec-builtin,S103	bad-file-permissions,S50	,S3	hashlib-insecure-hash-function,S501	request-with-no-cert-validation,S1	,S60	hardcoded-sql-expression,S105	hardcoded-password-string,S506	unsafe-yaml-load,S324	hashlib-insecure-hash-function,S5	,S104	hardcoded-bind-all-interfaces,S106	hardcoded-password-func-arg,S112	try-except-continue,S101	assert,S509	snmp-weak-cryptography,S11	,S32	hashlib-insecure-hash-function,S61	logging-config-insecure-listen,S107	hardcoded-password-default,S7	jinja2-autoescape-false,S113	request-without-timeout,S612	logging-config-insecure-listen,S110	try-except-pass,S608	hardcoded-sql-expression,S70	jinja2-autoescape-false,S701	jinja2-autoescape-false,S508	snmp-insecure-version,S10	,S108	hardcoded-temp-file,S6	,BLE001	blind-except,BLE0	blind-except,BLE00	blind-except,FBT0	,FBT001	boolean-positional-arg-in-function-definition,FBT00	,FBT003	boolean-positional-value-in-function-call,FBT002	boolean-default-value-in-function-definition,B023	function-uses-loop-variable,B014	duplicate-handler-exception,B025	duplicate-try-block-exception,B01	,B020	loop-variable-overrides-iterator,B007	unused-loop-control-variable,B027	empty-method-without-abstract-decorator,B904	raise-without-from-inside-except,B013	redundant-tuple-in-exception-handler,B018	useless-expression,B905	zip-without-explicit-strict,B9	,B0	,B032	unintentional-type-annotation,B02	,B008	function-call-argument-default,B009	get-attr-with-constant,B024	abstract-base-class-without-abstract-method,B03	unintentional-type-annotation,B026	star-arg-unpacking-after-keyword-arg,B022	useless-contextlib-suppress,B019	cached-instance-method,B005	strip-with-multi-characters,B00	,B003	assignment-to-os-environ,B011	assert-false,B021	f-string-docstring,B90	,B010	set-attr-with-constant,B004	unreliable-callable-check,B017	assert-raises-exception,B012	jump-statement-in-finally,B016	cannot-raise-literal,B002	unary-prefix-increment,B006	mutable-argument-default,B015	useless-comparison,B029	except-with-empty-tuple,A00	,A0	,A001	builtin-variable-shadowing,A003	builtin-attribute-shadowing,A002	builtin-argument-shadowing,COM818	trailing-comma-on-bare-tuple-prohibited,COM8	,COM819	trailing-comma-prohibited,COM81	,COM812	trailing-comma-missing,C410	unnecessary-literal-within-list-call,C400	unnecessary-generator-list,C414	unnecessary-double-cast-or-process,C402	unnecessary-generator-dict,C404	unnecessary-list-comprehension-dict,C415	unnecessary-subscript-reversal,C417	unnecessary-map,C41	,C416	unnecessary-comprehension,C409	unnecessary-literal-within-tuple-call,C401	unnecessary-generator-set,C413	unnecessary-call-around-sorted,C40	,C403	unnecessary-list-comprehension-set,C405	unnecessary-literal-set,C408	unnecessary-collection-call,C411	unnecessary-list-call,C406	unnecessary-literal-dict,DTZ01	,DTZ002	call-datetime-today,DTZ007	call-datetime-strptime-without-zone,DTZ001	call-datetime-without-tzinfo,DTZ004	call-datetime-utcfromtimestamp,DTZ003	call-datetime-utcnow,DTZ0	,DTZ00	,DTZ006	call-datetime-fromtimestamp,DTZ005	call-datetime-now-without-tzinfo,DTZ011	call-date-today,DTZ012	call-date-fromtimestamp,T100	debugger,DJ008	model-without-dunder-str,DJ001	nullable-model-string-field,DJ0	,DJ003	locals-in-render-function,DJ007	all-with-model-form,DJ006	exclude-with-model-form,DJ013	non-leading-receiver-decorator,DJ00	,DJ01	non-leading-receiver-decorator,EM102	f-string-in-exception,EM101	raw-string-in-exception,EM1	,EM103	dot-format-in-exception,EM10	,EXE003	shebang-python,EXE0	,EXE00	,EXE002	shebang-missing-executable-file,EXE005	shebang-newline,EXE001	shebang-not-executable,EXE004	shebang-whitespace,ISC00	,ISC002	multi-line-implicit-string-concatenation,ISC001	single-line-implicit-string-concatenation,ISC003	explicit-string-concatenation,ISC0	,ICN00	unconventional-import-alias,ICN001	unconventional-import-alias,ICN0	unconventional-import-alias,G010	logging-warn,G101	logging-extra-attr-clash,G2	,G01	logging-warn,G1	logging-extra-attr-clash,G004	logging-f-string,G003	logging-string-concat,G10	logging-extra-attr-clash,G002	logging-percent-format,G0	,G00	,G201	logging-exc-info,G202	logging-redundant-exc-info,G001	logging-string-format,G20	,INP001	implicit-namespace-package,INP0	implicit-namespace-package,INP00	implicit-namespace-package,PIE807	prefer-list-builtin,PIE802	unnecessary-comprehension-any-all,PIE80	,PIE796	prefer-unique-enums,PIE810	single-starts-ends-with,PIE79	,PIE7	,PIE800	unnecessary-spread,PIE790	unnecessary-pass,PIE794	dupe-class-field-definitions,PIE8	,PIE81	single-starts-ends-with,PIE804	unnecessary-dict-kwargs,T203	p-print-found,T201	print-found,PYI03	type-comment-in-stub,PYI007	unrecognized-platform-check,PYI021	docstring-in-stub,PYI02	docstring-in-stub,PYI001	prefix-type-params,PYI006	bad-version-info-comparison,PYI010	non-empty-stub-body,PYI014	argument-simple-defaults,PYI0	,PYI009	pass-statement-stub-body,PYI008	unrecognized-platform-name,PYI033	type-comment-in-stub,PYI00	,PYI011	typed-argument-simple-defaults,PYI01	,PT007	parametrize-values-wrong-type,PT017	assert-in-except,PT023	incorrect-mark-parentheses-style,PT02	,PT005	incorrect-fixture-name-underscore,PT010	raises-without-exception,PT020	deprecated-yield-fixture,PT021	fixture-finalizer-callback,PT024	unnecessary-asyncio-mark-on-fixture,PT00	,PT012	raises-with-multiple-statements,PT003	extraneous-scope-function,PT01	,PT026	use-fixtures-without-parameters,PT008	patch-with-lambda,PT001	incorrect-fixture-parentheses-style,PT018	composite-assertion,PT006	parametrize-names-wrong-type,PT015	assert-always-false,PT022	useless-yield-fixture,PT002	fixture-positional-args,PT004	missing-fixture-name-underscore,PT009	unittest-assertion,PT013	incorrect-pytest-import,PT016	fail-without-message,PT019	fixture-param-without-value,PT025	erroneous-use-fixtures-on-fixture,PT0	,PT011	raises-too-broad,Q003	avoidable-escaped-quote,Q000	bad-quotes-inline-string,Q002	bad-quotes-docstring,Q0	,Q00	,Q001	bad-quotes-multiline-string,RSE102	unnecessary-paren-on-raise-exception,RSE1	unnecessary-paren-on-raise-exception,RSE10	unnecessary-paren-on-raise-exception,RET50	,RET504	unnecessary-assign,RET508	superfluous-else-break,RET501	unnecessary-return-none,RET502	implicit-return-value,RET503	implicit-return,RET505	superfluous-else-return,RET507	superfluous-else-continue,RET5	,RET506	superfluous-else-raise,SLF00	private-member-access,SLF0	private-member-access,SLF001	private-member-access,SIM2	,SIM112	use-capital-environment-variables,SIM201	negate-equal-op,SIM103	needless-bool,SIM110	reimplemented-builtin,SIM115	open-file-with-context-handler,SIM223	expr-and-false,SIM222	expr-or-true,SIM109	compare-with-tuple,SIM3	yoda-conditions,SIM401	dict-get-with-default,SIM102	collapsible-if,SIM1	,SIM108	use-ternary-operator,SIM210	if-expr-with-true-false,SIM20	,SIM105	use-contextlib-suppress,SIM107	return-in-try-except-finally,SIM4	dict-get-with-default,SIM118	key-in-dict,SIM116	manual-dict-lookup,SIM211	if-expr-with-false-true,SIM10	,SIM40	dict-get-with-default,SIM221	expr-or-not-expr,SIM30	yoda-conditions,SIM114	if-with-same-arms,SIM22	,SIM117	multiple-with-statements,SIM208	double-negation,SIM300	yoda-conditions,SIM202	negate-not-equal-op,SIM21	,SIM101	duplicate-isinstance-call,SIM220	expr-and-not-expr,SIM212	if-expr-with-twisted-arms,SIM11	,TID251	banned-api,TID252	relative-imports,TID2	,TID25	,TCH003	typing-only-standard-library-import,TCH004	runtime-import-in-type-checking-block,TCH002	typing-only-third-party-import,TCH001	typing-only-first-party-import,TCH005	empty-type-checking-block,TCH0	,TCH00	,ARG003	unused-class-method-argument,ARG0	,ARG00	,ARG002	unused-method-argument,ARG005	unused-lambda-argument,ARG004	unused-static-method-argument,ARG001	unused-function-argument,PTH116	pathlib-stat,PTH122	pathlib-splitext,PTH104	pathlib-rename,PTH110	pathlib-exists,PTH121	pathlib-samefile,PTH108	pathlib-unlink,PTH123	pathlib-open,PTH107	pathlib-remove,PTH119	pathlib-basename,PTH10	,PTH118	pathlib-join,PTH101	pathlib-chmod,PTH114	pathlib-is-link,PTH100	pathlib-abspath,PTH11	,PTH102	pathlib-mkdir,PTH120	pathlib-dirname,PTH124	pathlib-py-path,PTH1	,PTH111	pathlib-expanduser,PTH105	pathlib-replace,PTH113	pathlib-is-file,PTH117	pathlib-is-abs,PTH115	pathlib-readlink,PTH103	pathlib-makedirs,PTH109	pathlib-getcwd,PTH106	pathlib-rmdir,PTH12	,PTH112	pathlib-is-dir,I00	,I0	,I002	missing-required-import,I001	unsorted-imports,C901	complex-structure,NPY0	,NPY00	,NPY001	numpy-deprecated-type-alias,NPY002	numpy-legacy-random,N805	invalid-first-argument-name-for-method,N81	,N804	invalid-first-argument-name-for-class-method,N999	invalid-module-name,N802	invalid-function-name,N807	dunder-function-name,N815	mixed-case-variable-in-class-scope,N818	error-suffix-on-exception-name,N80	,N816	mixed-case-variable-in-global-scope,N806	non-lowercase-variable-in-function,N811	constant-imported-as-non-constant,N813	camelcase-imported-as-lowercase,N803	invalid-argument-name,N8	,N99	invalid-module-name,N812	lowercase-imported-as-non-lowercase,N9	invalid-module-name,N801	invalid-class-name,N817	camelcase-imported-as-acronym,N814	camelcase-imported-as-constant,PD9	df-is-a-bad-variable-name,PD015	use-of-pd-merge,PD002	use-of-inplace-argument,PD013	use-of-dot-stack,PD01	,PD0	,PD00	,PD901	df-is-a-bad-variable-name,PD003	use-of-dot-is-null,PD012	use-of-dot-read-table,PD008	use-of-dot-at,PD009	use-of-dot-iat,PD010	use-of-dot-pivot-or-unstack,PD007	use-of-dot-ix,PD004	use-of-dot-not-null,PD011	use-of-dot-values,PD90	df-is-a-bad-variable-name,W292	no-new-line-at-end-of-file,E7	,E73	lambda-assignment,W5	doc-line-too-long,W6	invalid-escape-sequence,W60	invalid-escape-sequence,E40	,E402	module-import-not-at-top-of-file,E71	,W29	,E702	multiple-statements-on-one-line-semicolon,E501	line-too-long,E99	syntax-error,E713	not-in-test,E10	mixed-spaces-and-tabs,E50	line-too-long,E70	,E72	,W293	blank-line-contains-whitespace,E742	ambiguous-class-name,W291	trailing-whitespace,E9	,W19	indentation-contains-tabs,E711	none-comparison,W2	,E731	lambda-assignment,E401	multiple-imports-on-one-line,E721	type-comparison,E74	,W1	indentation-contains-tabs,E1	mixed-spaces-and-tabs,W605	invalid-escape-sequence,E703	useless-semicolon,E714	not-is-test,E902	io-error,W505	doc-line-too-long,E4	,E90	io-error,E	,E712	true-false-comparison,W191	indentation-contains-tabs,E701	multiple-statements-on-one-line-colon,E5	line-too-long,E743	ambiguous-function-name,W	,W50	doc-line-too-long,E722	bare-except,E999	syntax-error,E741	ambiguous-variable-name,E101	mixed-spaces-and-tabs,D300	triple-single-quotes,D103	public-function,D405	capitalize-section-name,D4	,D40	,D205	blank-line-after-summary,D213	multi-line-summary-second-line,D409	section-underline-matches-section-length,D417	undocumented-param,D200	fits-on-one-line,D401	non-imperative-mood,D402	no-signature,D410	blank-line-after-section,D105	magic-method,D202	no-blank-line-after-function,D209	new-line-after-last-paragraph,D107	public-init,D214	section-not-over-indented,D407	dashed-underline-after-section,D414	empty-docstring-section,D416	section-name-ends-in-colon,D418	overload-with-docstring,D10	,D211	no-blank-line-before-class,D400	ends-in-period,D408	section-underline-after-name,D20	,D104	public-package,D301	escape-sequence-in-docstring,D203	one-blank-line-before-class,D208	no-over-indentation,D419	empty-docstring,D207	no-under-indentation,D100	public-module,D21	,D101	public-class,D212	multi-line-summary-first-line,D210	no-surrounding-whitespace,D204	one-blank-line-after-class,D3	,D30	,D102	public-method,D106	public-nested-class,D41	,D403	first-line-capitalized,D406	new-line-after-section-name,D415	ends-in-punctuation,D413	blank-line-after-last-section,D404	docstring-starts-with-this,D412	no-blank-lines-between-header-and-content,D411	blank-line-before-section,D1	,D2	,D201	no-blank-line-before-function,D206	indent-with-spaces,D215	section-underline-not-over-indented,F622	two-starred-expressions,F602	multi-value-repeated-key-variable,F84	,F404	late-future-import,F503	percent-format-expected-sequence,F60	,F81	redefined-while-unused,F407	future-feature-not-defined,F842	unused-annotation,F40	,F508	percent-format-star-requires-sequence,F901	raise-not-implemented,F54	f-string-missing-placeholders,F525	string-dot-format-mixing-automatic,F707	default-except-not-last,F521	string-dot-format-invalid-format,F6	,F50	,F70	,F9	raise-not-implemented,F841	unused-variable,F632	is-literal,F401	unused-import,F403	import-star,F811	redefined-while-unused,F541	f-string-missing-placeholders,F702	continue-outside-loop,F505	percent-format-missing-argument,F72	forward-annotation-syntax-error,F504	percent-format-extra-named-arguments,F4	,F523	string-dot-format-extra-positional-arguments,F621	expressions-in-star-assignment,F52	,F701	break-outside-loop,F631	assert-tuple,F821	undefined-name,F8	,F509	percent-format-unsupported-format-character,F405	import-star-usage,F507	percent-format-positional-count-mismatch,F506	percent-format-mixed-positional-and-named,F722	forward-annotation-syntax-error,F62	,F82	,F634	if-tuple,F7	,F706	return-outside-function,F502	percent-format-expected-mapping,F601	multi-value-repeated-key-literal,F63	,F406	import-star-not-permitted,F402	import-shadowed-by-loop-var,F501	percent-format-invalid-format,F524	string-dot-format-missing-arguments,F90	raise-not-implemented,F522	string-dot-format-extra-named-arguments,F823	undefined-local,F633	invalid-print-syntax,F822	undefined-export,F704	yield-outside-function,F5	,PGH003	blanket-type-ignore,PGH002	deprecated-log-warn,PGH004	blanket-noqa,PGH001	no-eval,PGH0	,PGH00	,PLR02	property-with-parameters,PLR2	magic-value-comparison,PLW012	useless-else-on-loop,PLR	,PLR091	,PLW0120	useless-else-on-loop,PLW0603	global-statement,PLE1142	await-outside-async,PLR0206	property-with-parameters,PLE	,PLE1307	bad-string-format-type,PLR1722	consider-using-sys-exit,PLR5501	collapsible-else-if,PLR04	consider-using-from-import,PLC30	unnecessary-direct-lambda-call,PLE130	bad-string-format-type,PLR5	collapsible-else-if,PLW29	redefined-loop-name,PLE1205	logging-too-many-args,PLR20	magic-value-comparison,PLC300	unnecessary-direct-lambda-call,PLE11	await-outside-async,PLW01	useless-else-on-loop,PLE0100	yield-in-init,PLC3	unnecessary-direct-lambda-call,PLW290	redefined-loop-name,PLC0	useless-import-alias,PLE0117	nonlocal-without-binding,PLC0414	useless-import-alias,PLR0912	too-many-branches,PLR1701	consider-merging-isinstance,PLE25	bidirectional-unicode,PLR09	,PLR0402	consider-using-from-import,PLC041	useless-import-alias,PLE250	bidirectional-unicode,PLE0101	return-in-init,PLE1310	bad-str-strip-call,PLR0911	too-many-return-statements,PLR0915	too-many-statements,PLR17	,PLE011	,PLE13	,PLE1206	logging-too-few-args,PLE0604	invalid-all-object,PLE01	,PLE131	bad-str-strip-call,PLE010	,PLR2004	magic-value-comparison,PLR170	consider-merging-isinstance,PLR172	consider-using-sys-exit,PLW	,PLW060	,PLE120	,PLE0	,PLC04	useless-import-alias,PLE2502	bidirectional-unicode,PLR0913	too-many-arguments,PLR020	property-with-parameters,PLE2	bidirectional-unicode,PLR0133	comparison-of-constant,PLR040	consider-using-from-import,PLR55	collapsible-else-if,PLE1	,PLR550	collapsible-else-if,PLW2	redefined-loop-name,PLR200	magic-value-comparison,PLE12	,PLW06	,PLE060	,PLC3002	unnecessary-direct-lambda-call,PLW2901	redefined-loop-name,PLR0	,PLE0605	invalid-all-format,PLE114	await-outside-async,PLC	,PLW0	,PLW0602	global-variable-not-assigned,PLE0118	used-prior-global-declaration,PLE06	,PLR1	,PLR01	comparison-of-constant,PLR013	comparison-of-constant,UP021	replace-universal-newlines,UP010	unnecessary-future-import,UP011	lru-cache-without-parameters,UP01	,UP03	,UP025	rewrite-unicode-literal,UP035	import-replacements,UP026	rewrite-mock-import,UP030	format-literals,UP001	useless-metaclass-type,UP0	,UP007	typing-union,UP003	type-of-primitive,UP017	datetime-timezone-utc,UP022	replace-stdout-stderr,UP037	quoted-annotation,UP009	utf8-encoding-declaration,UP038	isinstance-with-tuple,UP006	deprecated-collection-type,UP008	super-call-with-parameters,UP023	rewrite-c-element-tree,UP013	convert-typed-dict-functional-to-class,UP032	f-string,UP004	useless-object-inheritance,UP018	native-literals,UP031	printf-string-formatting,UP00	,UP005	deprecated-unittest-alias,UP020	open-alias,UP029	unnecessary-builtin-import,UP02	,UP014	convert-named-tuple-functional-to-class,UP012	unnecessary-encode-utf8,UP015	redundant-open-modes,UP019	typing-text-str-alias,UP024	os-error-alias,UP028	rewrite-yield-from,UP033	functools-cache,UP034	extraneous-parentheses,UP036	outdated-version-block,UP027	rewrite-list-comprehension,RUF006	asyncio-dangling-task,RUF00	,RUF1	unused-noqa,RUF001	ambiguous-unicode-character-string,RUF100	unused-noqa,RUF005	unpack-instead-of-concatenating-to-collection-literal,RUF002	ambiguous-unicode-character-docstring,RUF10	unused-noqa,RUF0	,RUF003	ambiguous-unicode-character-comment,TRY20	,TRY200	reraise-no-cause,TRY300	try-consider-else,TRY201	verbose-raise,TRY401	verbose-log-message,TRY40	,TRY004	prefer-type-error,TRY002	raise-vanilla-class,TRY30	,TRY00	,TRY0	,TRY4	,TRY2	,TRY301	raise-within-try,TRY003	raise-vanilla-args,TRY400	error-instead-of-exception,TRY3	}"
complete -c ruff -n "__fish_seen_subcommand_from check" -l line-length -d 'Set the line-length for length-associated rules and automatic formatting' -r
complete -c ruff -n "__fish_seen_subcommand_from check" -l dummy-variable-rgx -d 'Regular expression matching the name of dummy variables' -r
complete -c ruff -n "__fish_seen_subcommand_from check" -l cache-dir -d 'Path to the cache directory' -r -F
complete -c ruff -n "__fish_seen_subcommand_from check" -l stdin-filename -d 'The name of the file when passing it through stdin' -r -F
complete -c ruff -n "__fish_seen_subcommand_from check" -l fix -d 'Attempt to automatically fix lint violations'
complete -c ruff -n "__fish_seen_subcommand_from check" -l no-fix
complete -c ruff -n "__fish_seen_subcommand_from check" -l show-source -d 'Show violations with source code'
complete -c ruff -n "__fish_seen_subcommand_from check" -l no-show-source
complete -c ruff -n "__fish_seen_subcommand_from check" -l show-fixes -d 'Show an enumeration of all autofixed lint violations'
complete -c ruff -n "__fish_seen_subcommand_from check" -l no-show-fixes
complete -c ruff -n "__fish_seen_subcommand_from check" -l diff -d 'Avoid writing any fixed files back; instead, output a diff for each changed file to stdout'
complete -c ruff -n "__fish_seen_subcommand_from check" -s w -l watch -d 'Run in watch mode by re-running whenever files change'
complete -c ruff -n "__fish_seen_subcommand_from check" -l fix-only -d 'Fix any fixable lint violations, but don\'t report on leftover violations. Implies `--fix`'
complete -c ruff -n "__fish_seen_subcommand_from check" -l no-fix-only
complete -c ruff -n "__fish_seen_subcommand_from check" -l ignore-noqa -d 'Ignore any `# noqa` comments'
complete -c ruff -n "__fish_seen_subcommand_from check" -l respect-gitignore -d 'Respect file exclusions via `.gitignore` and other standard ignore files'
complete -c ruff -n "__fish_seen_subcommand_from check" -l no-respect-gitignore
complete -c ruff -n "__fish_seen_subcommand_from check" -l force-exclude -d 'Enforce exclusions, even for paths passed to Ruff directly on the command-line'
complete -c ruff -n "__fish_seen_subcommand_from check" -l no-force-exclude
complete -c ruff -n "__fish_seen_subcommand_from check" -s n -l no-cache -d 'Disable cache reads'
complete -c ruff -n "__fish_seen_subcommand_from check" -l isolated -d 'Ignore all configuration files'
complete -c ruff -n "__fish_seen_subcommand_from check" -s e -l exit-zero -d 'Exit with status code "0", even upon detecting lint violations'
complete -c ruff -n "__fish_seen_subcommand_from check" -l exit-non-zero-on-fix -d 'Exit with a non-zero status code if any files were modified via autofix, even if no lint violations remain'
complete -c ruff -n "__fish_seen_subcommand_from check" -l update-check -d 'Does nothing and will be removed in the future'
complete -c ruff -n "__fish_seen_subcommand_from check" -l no-update-check
complete -c ruff -n "__fish_seen_subcommand_from check" -l statistics -d 'Show counts for every rule with at least one violation'
complete -c ruff -n "__fish_seen_subcommand_from check" -l add-noqa -d 'Enable automatic additions of `noqa` directives to failing lines'
complete -c ruff -n "__fish_seen_subcommand_from check" -l show-files -d 'See the files Ruff will be run against with the current settings'
complete -c ruff -n "__fish_seen_subcommand_from check" -l show-settings -d 'See the settings Ruff will use to lint a given Python file'
complete -c ruff -n "__fish_seen_subcommand_from check" -s v -l verbose -d 'Enable verbose logging'
complete -c ruff -n "__fish_seen_subcommand_from check" -s q -l quiet -d 'Print lint violations, but nothing else'
complete -c ruff -n "__fish_seen_subcommand_from check" -s s -l silent -d 'Disable all logging (but still exit with status code "1" upon detecting lint violations)'
complete -c ruff -n "__fish_seen_subcommand_from check" -s h -l help -d 'Print help'
complete -c ruff -n "__fish_seen_subcommand_from rule" -l format -d 'Output format' -r -f -a "{text	,json	}"
complete -c ruff -n "__fish_seen_subcommand_from rule" -s v -l verbose -d 'Enable verbose logging'
complete -c ruff -n "__fish_seen_subcommand_from rule" -s q -l quiet -d 'Print lint violations, but nothing else'
complete -c ruff -n "__fish_seen_subcommand_from rule" -s s -l silent -d 'Disable all logging (but still exit with status code "1" upon detecting lint violations)'
complete -c ruff -n "__fish_seen_subcommand_from rule" -s h -l help -d 'Print help'
complete -c ruff -n "__fish_seen_subcommand_from config" -s v -l verbose -d 'Enable verbose logging'
complete -c ruff -n "__fish_seen_subcommand_from config" -s q -l quiet -d 'Print lint violations, but nothing else'
complete -c ruff -n "__fish_seen_subcommand_from config" -s s -l silent -d 'Disable all logging (but still exit with status code "1" upon detecting lint violations)'
complete -c ruff -n "__fish_seen_subcommand_from config" -s h -l help -d 'Print help'
complete -c ruff -n "__fish_seen_subcommand_from linter" -l format -d 'Output format' -r -f -a "{text	,json	}"
complete -c ruff -n "__fish_seen_subcommand_from linter" -s v -l verbose -d 'Enable verbose logging'
complete -c ruff -n "__fish_seen_subcommand_from linter" -s q -l quiet -d 'Print lint violations, but nothing else'
complete -c ruff -n "__fish_seen_subcommand_from linter" -s s -l silent -d 'Disable all logging (but still exit with status code "1" upon detecting lint violations)'
complete -c ruff -n "__fish_seen_subcommand_from linter" -s h -l help -d 'Print help'
complete -c ruff -n "__fish_seen_subcommand_from clean" -s v -l verbose -d 'Enable verbose logging'
complete -c ruff -n "__fish_seen_subcommand_from clean" -s q -l quiet -d 'Print lint violations, but nothing else'
complete -c ruff -n "__fish_seen_subcommand_from clean" -s s -l silent -d 'Disable all logging (but still exit with status code "1" upon detecting lint violations)'
complete -c ruff -n "__fish_seen_subcommand_from clean" -s h -l help -d 'Print help'
complete -c ruff -n "__fish_seen_subcommand_from generate-shell-completion" -s v -l verbose -d 'Enable verbose logging'
complete -c ruff -n "__fish_seen_subcommand_from generate-shell-completion" -s q -l quiet -d 'Print lint violations, but nothing else'
complete -c ruff -n "__fish_seen_subcommand_from generate-shell-completion" -s s -l silent -d 'Disable all logging (but still exit with status code "1" upon detecting lint violations)'
complete -c ruff -n "__fish_seen_subcommand_from generate-shell-completion" -s h -l help -d 'Print help'
complete -c ruff -n "__fish_seen_subcommand_from help; and not __fish_seen_subcommand_from check; and not __fish_seen_subcommand_from rule; and not __fish_seen_subcommand_from config; and not __fish_seen_subcommand_from linter; and not __fish_seen_subcommand_from clean; and not __fish_seen_subcommand_from generate-shell-completion; and not __fish_seen_subcommand_from help" -f -a "check" -d 'Run Ruff on the given files or directories (default)'
complete -c ruff -n "__fish_seen_subcommand_from help; and not __fish_seen_subcommand_from check; and not __fish_seen_subcommand_from rule; and not __fish_seen_subcommand_from config; and not __fish_seen_subcommand_from linter; and not __fish_seen_subcommand_from clean; and not __fish_seen_subcommand_from generate-shell-completion; and not __fish_seen_subcommand_from help" -f -a "rule" -d 'Explain a rule'
complete -c ruff -n "__fish_seen_subcommand_from help; and not __fish_seen_subcommand_from check; and not __fish_seen_subcommand_from rule; and not __fish_seen_subcommand_from config; and not __fish_seen_subcommand_from linter; and not __fish_seen_subcommand_from clean; and not __fish_seen_subcommand_from generate-shell-completion; and not __fish_seen_subcommand_from help" -f -a "config" -d 'List or describe the available configuration options'
complete -c ruff -n "__fish_seen_subcommand_from help; and not __fish_seen_subcommand_from check; and not __fish_seen_subcommand_from rule; and not __fish_seen_subcommand_from config; and not __fish_seen_subcommand_from linter; and not __fish_seen_subcommand_from clean; and not __fish_seen_subcommand_from generate-shell-completion; and not __fish_seen_subcommand_from help" -f -a "linter" -d 'List all supported upstream linters'
complete -c ruff -n "__fish_seen_subcommand_from help; and not __fish_seen_subcommand_from check; and not __fish_seen_subcommand_from rule; and not __fish_seen_subcommand_from config; and not __fish_seen_subcommand_from linter; and not __fish_seen_subcommand_from clean; and not __fish_seen_subcommand_from generate-shell-completion; and not __fish_seen_subcommand_from help" -f -a "clean" -d 'Clear any caches in the current directory and any subdirectories'
complete -c ruff -n "__fish_seen_subcommand_from help; and not __fish_seen_subcommand_from check; and not __fish_seen_subcommand_from rule; and not __fish_seen_subcommand_from config; and not __fish_seen_subcommand_from linter; and not __fish_seen_subcommand_from clean; and not __fish_seen_subcommand_from generate-shell-completion; and not __fish_seen_subcommand_from help" -f -a "generate-shell-completion" -d 'Generate shell completion'
complete -c ruff -n "__fish_seen_subcommand_from help; and not __fish_seen_subcommand_from check; and not __fish_seen_subcommand_from rule; and not __fish_seen_subcommand_from config; and not __fish_seen_subcommand_from linter; and not __fish_seen_subcommand_from clean; and not __fish_seen_subcommand_from generate-shell-completion; and not __fish_seen_subcommand_from help" -f -a "help" -d 'Print this message or the help of the given subcommand(s)'
